function y = auto_corr_fcn(x,tol)
%
% the input vector x is assumed to be nx1
% tol is a positive scalar close to zero reflecting when correlation is close to zero
%
if nargin==1;
   tol = 0.02;
end;

n = size(x,1);
%
% demean x to make sure
%
x = x-((1/n)*sum(x));
%
% compute the variance
%
y = (1/n)*x'*x;
%
crit = 1;
%
num = 1;
while crit>tol;
   z1 = x(1+num:n,1);
   z2 = x(1:n-num,1);
   yl = (1/n)*z1'*z2;
   crit = abs(yl/y(1,1));
   if crit>tol;
     y = [y;yl];
   end;
   num = num+1;
   if num==n;
      break;
   end;
end;

%
% end of auto_corr_fcn.m
%
