function axes_statistics_fcn

this_axes = gca;

%
% looking for lines
%
linehandles = findobj(gca,'Type','line')';
if isempty(linehandles)==0;
   %
   % Remove zero lines from linehandles
   %
   fixhandles = [];
   for j=1:size(linehandles,2);
      checkvec = get(linehandles(1,j),'YData');
      checkvec2 = sum(get(linehandles(1,j),'XData'));
      checkstyle = get(linehandles(1,j),'LineStyle');
      %
      % need to remove those with nolegend-, varline-, 2dlines-, 3dlines- tags
      %
      checktag = get(linehandles(1,j),'Tag');
      if size(checktag,2)>8;
         checktag = checktag(1,1:8);
      end;
      if (isalmostequal(checkvec,get(linehandles(1,j),'XData'))==1)|(((checkvec==zeros(size(checkvec,1),1))|(checkvec2==zeros(size(checkvec2,1),1)))&((strcmp(checkstyle,'none')==0)|(isempty(get(linehandles(1,j),'UserData'))==0))|(strcmp(get(linehandles(1,j),'Tag'),'light')==1))|(strcmp(checktag,'varline-')==1)|(strcmp(checktag,'nolegend')==1)|(strcmp(checktag,'2dlines-')==1)|(strcmp(checktag,'3dlines-')==1)|(min(checkvec)==max(checkvec));
         fixhandles = [fixhandles 0];
      else;
         fixhandles = [fixhandles 1];
      end;
   end;
   linehandles = linehandles(fixhandles==1);
end;

if (size(linehandles,1)==0)|(size(linehandles,2)==0);
   linehandles = [];
end;

%
% Looking for patches
%

patchhandles = findobj(gca,'Type','patch')';
if isempty(patchhandles)==0;
   %
   % remove rectangles and confidence intervals
   %
   fixhandles = [];
   for i=1:size(patchhandles,2);
      if (strcmp(get(patchhandles(1,i),'Tag'),'confpatch')==1)|(strcmp(get(patchhandles(1,i),'Tag'),'confpatch-new')==1)|(strcmp(lower(get(patchhandles(1,i),'Tag')),'rectpatch')==1)|(strcmp(lower(get(patchhandles(1,i),'Tag')),'rectpatch-new')==1)|(strcmp(get(patchhandles(1,i),'Tag'),'distpatch')==1)|(strcmp(get(patchhandles(1,i),'Tag'),'distpatch-new')==1)|(strcmp(get(patchhandles(1,i),'Tag'),'autopatch')==1)|(strcmp(get(patchhandles(1,i),'Tag'),'autopatch-new')==1);
         fixhandles = [fixhandles 0];
      else;
         fixhandles = [fixhandles 1];
      end;
   end;
   patchhandles = patchhandles(fixhandles==1);
end;

if (size(patchhandles,1)==0)|(size(patchhandles,2)==0);
   patchhandles = [];
end;

%
% now check the data for the lines and the patches
%

stat_objects = [];
num = 0;
max_freq = 12;
if isempty(linehandles)==0;
   for i=1:size(linehandles,2);
      x_data = get(linehandles(1,i),'XData');
      y_data = get(linehandles(1,i),'YData');
      %
      % check if the line is constructed from a stairs function. if so remove duplicates
      %
      res_tag = findstr(get(linehandles(1,i),'Tag'),'-stairs');
      if (isempty(res_tag)==0)&(max(size(x_data))>1);
         elem = (1:2:max(size(x_data)))';
         if size(x_data,1)>size(x_data,2);
            x_data = x_data(elem,:);
         else;
            x_data = x_data(:,elem);
         end;
         if size(y_data,1)>size(y_data,2);
            y_data = y_data(elem,:);
         else;
            y_data = y_data(:,elem);
         end;
      end;
      %
      % Try to figure out frequency and if we have an interesting line
      %
      if size(x_data,1)>1;
         x_data = x_data';
      end;
      if size(y_data,1)>1;
         y_data = y_data';
      end;
      l_freq = '';
      if size(x_data,2)>1;
         ch_freq = x_data(1,2)-x_data(1,1);
         if isalmostequal(ch_freq,1)==1;
            l_freq = 'y';
            this_freq = 1;
         elseif isalmostequal(ch_freq,1/4)==1;
            l_freq = 'q';
            this_freq = 4;
         elseif isalmostequal(ch_freq,1/12)==1;
            l_freq = 'm';
            this_freq = 12;
         end;
         check_matrix = max(max(y_data))*ones(size(y_data));
         if (strcmp(l_freq,'')==0)&(isalmostequal(y_data,check_matrix)==0);
            num = num+1;
            stat_objects(num).handle = linehandles(1,i);
            stat_objects(num).type = 'Line ';
            stat_objects(num).number = num2str(num);
            stat_objects(num).freq = this_freq;
            stat_objects(num).x_data = x_data;
            stat_objects(num).y_data = y_data;
            if this_freq<max_freq;
               max_freq = this_freq;
            end;
         end;
      end;
   end;
end;

if isempty(patchhandles)==0;
   for i=1:size(patchhandles,2);
      x_data = get(patchhandles(1,i),'XData');
      y_data = get(patchhandles(1,i),'YData');
      if size(x_data,1)>4;
         x_data = x_data';
      end;
      if size(y_data)>4;
         y_data = y_data';
      end;
      if (size(x_data,1)==4)&(size(y_data,1)==4);
         l_freq = '';
         %
         % checking the frequency for bars
         %
         x_data = (1/2)*(x_data(2,:)+x_data(3,:));
         y_data = y_data(2,:);
         if size(x_data,2)>1;
            ch_freq = x_data(1,2)-x_data(1,1);
            if isalmostequal(ch_freq,1)==1;
               l_freq = 'y';
               this_freq = 1;
            elseif isalmostequal(ch_freq,1/4)==1;
               l_freq = 'q';
               this_freq = 4;
            elseif isalmostequal(ch_freq,1/12)==1;
               l_freq = 'm';
               this_freq = 12;
            end;
            if strcmp(l_freq,'')==0;
               num = num+1;
               stat_objects(num).handle = patchhandles(1,i);
               stat_objects(num).type = 'Patch';
               stat_objects(num).number = int2str(i);
               stat_objects(num).freq = this_freq;
               stat_objects(num).x_data = x_data;
               stat_objects(num).y_data = y_data;
               if this_freq<max_freq;
                  max_freq = this_freq;
               end;
            end;
         end;
      end;
   end;
end;

if isempty(stat_objects)==0;
   x_lim = [];
   for i=1:size(stat_objects,2);
      %
      % First make sure that all data are measured by the same frequency
      %
      if stat_objects(i).freq~=max_freq;
         freq_vec = ceil((stat_objects(i).x_data-floor(stat_objects(i).x_data))*stat_objects(i).freq);
         if max_freq==1;
            if stat_objects(i).freq==4;
               %
               % convert from quarterly to yearly
               %
               if size(freq_vec,2)>=4;
                  if freq_vec(1,1)==2;
                     freq_vec(1,1:3) = [0 0 0];
                  elseif freq_vec(1,1)==3;
                     freq_vec(1,1:2) = [0 0];
                  elseif freq_vec(1,1)==4;
                     freq_vec(1,1) = 0;
                  end;
                  f_s = size(freq_vec,2);
                  if freq_vec(1,f_s)==1;
                     freq_vec(1,f_s) = 0;
                  elseif freq_vec(1,f_s)==2;
                     freq_vec(1,f_s-1:f_s) = [0 0];
                  elseif freq_vec(1,f_s)==3;
                     freq_vec(1,f_s-2:f_s) = [0 0 0];
                  end;
                  freq_vec = (freq_vec>zeros(1,f_s));
                  %
                  % keep only those observations that can be converted into yearly data
                  %
                  stat_objects(i).x_data = stat_objects(i).x_data(freq_vec==1);
                  stat_objects(i).y_data = stat_objects(i).y_data(freq_vec==1);
                  t_mat = transdata_matrix(4,size(stat_objects(i).x_data,2)/4);
                  stat_objects(i).x_data = floor(stat_objects(i).x_data*t_mat');
                  stat_objects(i).y_data = stat_objects(i).y_data*t_mat';
               else;
                  %
                  % object will be discarded
                  %
                  stat_objects(i).x_data = [];
               end;
            elseif stat_objects(i).freq==12;
               %
               % convert from monthly to yearly
               %
               if size(freq_vec,2)>=12;
                  if freq_vec(1,1)==2;
                     freq_vec(1,1:11) = zeros(1,11);
                  elseif freq_vec(1,1)==3;
                     freq_vec(1,1:10) = zeros(1,10);
                  elseif freq_vec(1,1)==4;
                     freq_vec(1,1:9) = zeros(1,9);
                  elseif freq_vec(1,1)==5;
                     freq_vec(1,1:8) = zeros(1,8);
                  elseif freq_vec(1,1)==6;
                     freq_vec(1,1:7) = zeros(1,7);
                  elseif freq_vec(1,1)==7;
                     freq_vec(1,1:6) = zeros(1,6);
                  elseif freq_vec(1,1)==8;
                     freq_vec(1,1:5) = zeros(1,5);
                  elseif freq_vec(1,1)==9;
                     freq_vec(1,1:4) = zeros(1,4);
                  elseif freq_vec(1,1)==10;
                     freq_vec(1,1:3) = zeros(1,3);
                  elseif freq_vec(1,1)==11;
                     freq_vec(1,1:2) = zeros(1,2);
                  elseif freq_vec(1,1)==12;
                     freq_vec(1,1) = 0;
                  end;
                  f_s = size(freq_vec,2);
                  if freq_vec(1,f_s)==1;
                     freq_vec(1,f_s) = 0;
                  elseif freq_vec(1,f_s)==2;
                     freq_vec(1,f_s-1:f_s) = zeros(1,2);
                  elseif freq_vec(1,f_s)==3;
                     freq_vec(1,f_s-2:f_s) = zeros(1,3);
                  elseif freq_vec(1,f_s)==4;
                     freq_vec(1,f_s-3:f_s) = zeros(1,4);
                  elseif freq_vec(1,f_s)==5;
                     freq_vec(1,f_s-4:f_s) = zeros(1,5);
                  elseif freq_vec(1,f_s)==6;
                     freq_vec(1,f_s-5:f_s) = zeros(1,6);
                  elseif freq_vec(1,f_s)==7;
                     freq_vec(1,f_s-6:f_s) = zeros(1,7);
                  elseif freq_vec(1,f_s)==8;
                     freq_vec(1,f_s-7:f_s) = zeros(1,8);
                  elseif freq_vec(1,f_s)==9;
                     freq_vec(1,f_s-8:f_s) = zeros(1,9);
                  elseif freq_vec(1,f_s)==10;
                     freq_vec(1,f_s-9:f_s) = zeros(1,10);
                  elseif freq_vec(1,f_s)==11;
                     freq_vec(1,f_s-10:f_s) = zeros(1,11);
                  end;
                  freq_vec = (freq_vec>zeros(1,f_s));
                  %
                  % keep only those observations that can be converted into yearly data
                  %
                  stat_objects(i).x_data = stat_objects(i).x_data(freq_vec==1);
                  stat_objects(i).y_data = stat_objects(i).y_data(freq_vec==1);
                  t_mat = transdata_matrix(12,size(stat_objects(i).x_data,2)/12);
                  stat_objects(i).x_data = floor(stat_objects(i).x_data*t_mat');
                  stat_objects(i).y_data = stat_objects(i).y_data*t_mat';
               else;
                  %
                  % object will be discarded
                  %
                  stat_objects(i).x_data = [];
               end;
            end;
         elseif (max_freq==4)&(size(freq_vec,2))>=3;
            %
            % convert from monthly to quarterly
            %
            if freq_vec(1,1)==2;
               freq_vec(1,1:2) = [0 0];
            elseif freq_vec(1,1)==3;
               freq_vec(1,1) = 0;
            elseif freq_vec(1,1)==5;
               freq_vec(1,1:2) = [0 0];
            elseif freq_vec(1,1)==6;
               freq_vec(1,1) = 0;
            elseif freq_vec(1,1)==8;
               freq_vec(1,1:2) = [0 0];
            elseif freq_vec(1,1)==9;
               freq_vec(1,1) = 0;
            elseif freq_vec(1,1)==11;
               freq_vec(1,1:2) = [0 0];
            elseif freq_vec(1,1)==12;
               freq_vec(1,1) = 0;
            end;
            f_s = size(freq_vec,2);
            if freq_vec(1,f_s)==1;
               freq_vec(1,f_s) = 0;
            elseif freq_vec(1,f_s)==2;
               freq_vec(1,f_s-1:f_s) = [0 0];
            elseif freq_vec(1,f_s)==4;
               freq_vec(1,f_s) = 0;
            elseif freq_vec(1,f_s)==5;
               freq_vec(1,f_s-1:f_s) = [0 0];
            elseif freq_vec(1,f_s)==7;
               freq_vec(1,f_s) = 0;
            elseif freq_vec(1,f_s)==8;
               freq_vec(1,f_s-1:f_s) = [0 0];
            elseif freq_vec(1,f_s)==10;
               freq_vec(1,f_s) = 0;
            elseif freq_vec(1,f_s)==11;
               freq_vec(1,f_s-1:f_s) = [0 0];
            end;
            freq_vec = (freq_vec>zeros(1,f_s));
            %
            % keep only those observations that can be converted into quarterly data
            %
            stat_objects(i).x_data = stat_objects(i).x_data(freq_vec==1);
            stat_objects(i).y_data = stat_objects(i).y_data(freq_vec==1);
            t_mat = transdata_matrix(3,size(stat_objects(i).x_data,2)/3);
            stat_objects(i).x_data = stat_objects(i).x_data*t_mat';
            stat_objects(i).y_data = stat_objects(i).y_data*t_mat';
         else;
            %
            % object will be discarded
            %
            stat_objects(i).x_data = [];
         end;
      end;
      %
      if isempty(stat_objects(i).x_data)==0;
         %
         % Find the largest common sample
         %
         if isempty(x_lim);
            x_lim = [stat_objects(i).x_data(1,1) stat_objects(i).x_data(1,size(stat_objects(i).x_data,2))];
         else;
            x_low = stat_objects(i).x_data(1,1);
            x_high = stat_objects(i).x_data(1,size(stat_objects(i).x_data,2));
            if x_low>x_lim(1,1);
               x_lim(1,1) = x_low;
            end;
            if x_high<x_lim(1,2);
               x_lim(1,2) = x_high;
            end;
         end;
      end;
   end;
   %
   % Make sure that the data cover the same period
   %
   if size(stat_objects,2)>1;
      for i=1:size(stat_objects,2);
         if isempty(stat_objects(i).x_data)==0;
            x_low = stat_objects(i).x_data(1,1);
            x_high = stat_objects(i).x_data(1,size(stat_objects(i).x_data,2));
            low_vec = (stat_objects(i).x_data>=x_lim(1,1)-1.0e-10);
            high_vec = (stat_objects(i).x_data<=x_lim(1,2)+1.0e-10);
            fix_vec = zeros(size(low_vec));
            for j=1:size(low_vec,2);
               if low_vec(1,j)==high_vec(1,j);
                  fix_vec(1,j) = 1;
               end;
            end;
            stat_objects(i).x_data = stat_objects(i).x_data(fix_vec==1);
            stat_objects(i).y_data = stat_objects(i).y_data(fix_vec==1);
         end;
      end;
   end;
   %
   % create variable names
   %
   tags = '';
   tag_ch = 0;
   for i=1:size(stat_objects,2);
      if isempty(stat_objects(i).x_data)==0;
         new_tag = strtrim(get(stat_objects(i).handle,'Tag'));
         pos = findstr(new_tag,'-stairs');
         if isempty(pos)==0;
            if pos>1;
               new_tag = new_tag(1,1:pos-1);
            else;
               new_tag = 'y-data';
            end;
         end;
         tags = strvcat(tags,new_tag);
         tag_ch = 1;
      end;
   end;
   my_spaces = '';
   if tag_ch==1;
      for i=1:size(tags,2);
         my_spaces = [my_spaces ' '];
      end;
   end;
   %
   % we're now ready to produce some data
   %
   txt = '';
   add_corr = '';
   corr_series = [];
   for i=1:size(stat_objects,2);
      if isempty(stat_objects(i).x_data)==0;
         if strcmp(txt,'')==1;
            txt = strvcat(' ','                     STATISTICS FOR PLOT','                     *******************',' ');
            curr_plot = get(get(gca,'Title'),'String');
            txt = strvcat(txt,['Current Plot Title: ' curr_plot],' ',['  Object  ' my_spaces '  Frequency      Sample          Mean         St.Dev.'],' ');
         end;
         mean_val = (1/size(stat_objects(i).y_data,2))*sum(stat_objects(i).y_data);
         std_val = sqrt((1/size(stat_objects(i).y_data,2))*sum(((stat_objects(i).y_data-mean_val).*(stat_objects(i).y_data-mean_val))));
         corr_series = [corr_series;stat_objects(i).y_data-mean_val];
         if max_freq==1;
            curr_freq = '  yearly ';
            this_freq = '';
            add_mean = ' ';
         elseif max_freq==4;
            curr_freq = 'quarterly';
            this_freq = 'q';
            add_mean = ' ';
         elseif max_freq==12;
            curr_freq = ' monthly ';
            this_freq = 'm';
            add_mean = '';
         end;
         add_std = '';
         if size(num2str(mean_val,'%0.0f'),2)==1;
            add_mean = [add_mean '  '];
         elseif size(num2str(mean_val,'%0.0f'),2)==2;
            add_mean = [add_mean ' '];
         end;
         if size(num2str(std_val,'%0.0f'),2)==1;
            add_std = [add_std '  '];
         elseif size(num2str(std_val,'%0.0f'),2)==2;
            add_std = [add_std ' '];
         end;
         %
         fp = stat_objects(i).x_data(1,1);
         nump = size(stat_objects(i).x_data,2);
         lp = stat_objects(i).x_data(1,nump);
         txt = strvcat(txt,[stat_objects(i).type ' #' stat_objects(i).number ' ' tags(i,:) '   ' curr_freq '  ' getdate(fp,lp,this_freq,1/nump) '-' getdate(fp,lp,this_freq,1) '   ' add_mean num2str(mean_val,'%0.6f') '   ' add_std num2str(std_val,'%0.6f')]);
         add_corr = strvcat(add_corr,[stat_objects(i).type ' #' stat_objects(i).number '   ']);
      end;
   end;
   if strcmp(txt,'')==0;
      txt = strvcat(txt,' ');
   end;
   %
   % Now we construct correlations if there are more than 2 series
   %
   if (isempty(corr_series)==0)&(size(corr_series,1)>1);
      %
      % temporary stuff
      %
%      [sea,sea_str] = seasonal_fcn('m',size(corr_series,2));
%      sea = [ones(size(sea,1),1) sea];
%      n_corr_series = [];
%      for i=1:size(stat_objects,2);
%         n_corr_series = [n_corr_series;stat_objects(i).y_data];
%      end;
      %
      % regress n_corr_series on sea
      %
%      b = n_corr_series*sea*inverse(sea'*sea);
%      corr_series = n_corr_series-(b*sea');
      %
      corrmat = (1/nump)*corr_series*corr_series';
      stddev = sqrt(diag(diag(corrmat)));
      for i=1:size(corrmat,1);
         for j=1:size(corrmat,1);
            corrmat(i,j) = corrmat(i,j)/(stddev(i,i)*stddev(j,j));
         end;
      end;
      add_corr = [add_corr num2str(corrmat,'%12.6f')];
      txt = strvcat(txt,'Correlation matrix:',' ',add_corr,' ');
      %
      % compute some autocorrelations
      %
      autocorrmat = zeros(size(corr_series,1)*(size(corr_series,1)-1),max_freq+1);
      for i=1:size(corr_series,1);
         %
         % for we take the lags
         %
         for j=0:max_freq;
            if j<size(corr_series,2)-j;
               own_corrseries = corr_series(i,1+j:size(corr_series,2));
               other_corrseries = corr_series(setdiff((1:1:size(corr_series,1)),i),1:size(corr_series,2)-j);
               num_p = size(own_corrseries,2);
               covmat = (1/num_p)*other_corrseries*own_corrseries';
               adj_mat = stddev(i,i)*stddev(setdiff((1:1:size(corr_series,1)),i),setdiff((1:1:size(corr_series,1)),i));
               autocorrmat(1+(size(corr_series,1)-1)*(i-1):(size(corr_series,1)-1)*i,max_freq-j+1) = inverse(adj_mat)*covmat;
            else;
               autocorrmat(1+(size(corr_series,1)-1)*(i-1):(size(corr_series,1)-1)*i,max_freq-j+1) = NaN*ones((size(corr_series,1)-1),1);
            end;
         end;
      end;
      %
      % write to the output file
      %
      num = 1;
      txt = strvcat(txt,'Autocorrelation results',' ');
      lag_txt = '      Lag  0';
      for i=1:max_freq;
         if i<max_freq;
            if i<10;
               lag_txt = ['      Lag  ' num2str(i,'%0.0f') lag_txt];
            else;
               lag_txt = ['      Lag ' num2str(i,'%0.0f') lag_txt];
            end;
         else;
            if i<10;
               lag_txt = ['  Lag  ' num2str(i,'%0.0f') lag_txt];
            else;
               lag_txt = ['  Lag ' num2str(i,'%0.0f') lag_txt];
            end;
         end;
      end;
      for i=1:size(corr_series,1);
         for j=1:size(corr_series,1);
            if j~=i;
               txt = strvcat(txt,['(' stat_objects(i).type ' #' stat_objects(i).number ') ' tags(i,:) ' and lags of (' stat_objects(j).type ' #' stat_objects(j).number ') ' tags(j,:)]);
               txt = strvcat(txt,lag_txt,num2str(autocorrmat(num,:),'%12.6f'),' ');
               num = num+1;
            end;
         end;
      end;
   end;
   if strcmp(txt,'')==1;
      txt = strvcat(' ','Structural VAR didn''t find any time series data to compute','statistics on.');
   end;
else;
   txt = strvcat(' ','Structural VAR didn''t find any time series data to compute','statistics on.');
end;

realscrsz = get(0,'ScreenSize');
textgui(txt,'Structural VAR - Statistics',[(realscrsz(3)-735)/2 (realscrsz(4)-400)/2 735 400],'Plot Statistics',65);

%
% end of axes_statistics_fcn.m
%
