function change_legend_font

text_strings = findobj(gca,'Type','text')';
legh = gca;

if isempty(text_strings)==0;
   font_prop = uisetfont(text_strings(1,1),'Legend Font');
   if isnumeric(font_prop)==0;
      ud = get(gca,'UserData');
      if isfield(ud,'PlotHandle')==1;
         this_axes = ud.PlotHandle;
         h = gcf;
         if iscompiled==1;
            toolbar = get(h,'UserData');
            my_fonts = get(toolbar.new,'UserData');
         else;
            ax_par = get(this_axes,'UserData');
            if isempty(ax_par)==0;
               if isstruct(ax_par)==1;
                  my_fonts = ax_par;
               else;
                  my_fonts = [];
               end;
            else;
               my_fonts = [];
            end;
         end;
         if isempty(my_fonts)==1;
            fontpos = 1;
         else;
            myfonts = my_fonts;
            num_parents = size(myfonts.parent,2);
            fontpos = 0;
            for i=1:num_parents;
               if myfonts.parent(i)==this_axes;
                  fontpos = i;
                  break;
               end;
            end;
            if fontpos==0;
               fontpos = num_parents+1;
            end;
         end;
      end;
      for i=1:size(text_strings,2);
         if ischar(font_prop.FontName)==1;
            set(text_strings(1,i),'FontName',font_prop.FontName);
            myfonts.font(fontpos).fontname = font_prop.FontName;
         end;
         if isnumeric(font_prop.FontSize)==1;
            set(text_strings(1,i),'FontSize',font_prop.FontSize);
            myfonts.font(fontpos).fontsize = font_prop.FontSize;
         end;
         if ischar(font_prop.FontWeight)==1;
            set(text_strings(1,i),'FontWeight',font_prop.FontWeight);
            myfonts.font(fontpos).fontweight = font_prop.FontWeight;
         end;
         if ischar(font_prop.FontAngle)==1;
            set(text_strings(1,i),'FontAngle',font_prop.FontAngle);
            myfonts.font(fontpos).fontangle = font_prop.FontAngle;
         end;
         if ischar(font_prop.FontUnits)==1;
            set(text_strings(1,i),'FontUnits',font_prop.FontUnits);
            myfonts.font(fontpos).fontunits = font_prop.FontUnits;
         end;
         myfonts.parent(fontpos) = this_axes;
         if iscompiled==1;
            set(toolbar.new,'UserData',myfonts);
         else;
            set(this_axes,'UserData',myfonts);
         end;
      end;
      %
      % retrieve old context menu
      %
      newcontext = [];
      if isfield(ud,'UIContextMenu')==1;
         if ishandle(ud.UIContextMenu)==1;
            kids = get(ud.UIContextMenu,'Children')';
            if isempty(kids)==0;
               kids = sort(kids);
               newcontext = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
               for i=1:size(kids,2);
                  uimenu('Parent',newcontext,'Label',get(kids(1,i),'Label'),'Separator',get(kids(1,i),'Separator'),'Callback',get(kids(1,i),'Callback'));
               end;
            end;
         end;
      end;
      %
      % find old legend font and color properties
      %
      old_color = get(legh,'Color');
      old_border_color = get(legh,'XColor');
      text_strings = findobj(legh,'Type','text')';
      if isempty(text_strings)==0;
         text_obj.color = get(text_strings(1,1),'Color');
         text_obj.fontangle = get(text_strings(1,1),'FontAngle');
         text_obj.fontname = get(text_strings(1,1),'FontName');
         text_obj.fontsize = get(text_strings(1,1),'FontSize');
         text_obj.fontweight = get(text_strings(1,1),'FontWeight');
         text_obj.fontunits = get(text_strings(1,1),'FontUnits');
      end;
      %
      % update the legend in case it needs to be resized
      %
      new_leg = update_legend(legh);
      %
      % fix legend so that all properties match the old ones
      %
      if isempty(newcontext)==0;
         if ishandle(new_leg)==1;
            new_ud = get(new_leg,'UserData');
            new_ud.UIContextMenu = newcontext;
            set(new_leg,'UIContextMenu',newcontext,'UserData',new_ud,'Color',old_color,'XColor',old_border_color,'YColor',old_border_color);
            set(get(new_leg,'Children'),'UIContextMenu',newcontext);
            new_text_strings = findobj(new_leg,'Type','text')';
            if isempty(new_text_strings)==0;
               for i=1:size(new_text_strings,2);
                  set(new_text_strings(1,i),'Color',text_obj.color);
                  set(new_text_strings(1,i),'FontAngle',text_obj.fontangle);
                  set(new_text_strings(1,i),'FontName',text_obj.fontname);
                  set(new_text_strings(1,i),'FontSize',text_obj.fontsize);
                  set(new_text_strings(1,i),'FontWeight',text_obj.fontweight);
                  set(new_text_strings(1,i),'FontUnits',text_obj.fontunits);
               end;
            end;
            this_leg_line = sort(findobj(new_leg,'Type','line')');
            this_line = sort(findobj(new_ud.PlotHandle,'Type','line')');
            fixhandles = [];
            if isempty(this_line)==0;
               for j=1:size(this_line,2);
                  checkvec = get(this_line(1,j),'YData');
                  checkvec2 = sum(get(this_line(1,j),'XData'));
                  checkstyle = get(this_line(1,j),'LineStyle');
                  checktag = get(this_line(1,j),'Tag');
                  if size(checktag,2)>8;
                     checktag = checktag(1,1:8);
                  end;
                  if ((checkvec==zeros(size(checkvec,1),1))|(checkvec2==zeros(size(checkvec2,1),1)))&((strcmp(checkstyle,'none')==0)|(isempty(get(this_line(1,j),'UserData'))==0))|(strcmp(checktag,'nolegend')==1)|(strcmp(checktag,'nolegend')==1)|(strcmp(checktag,'light')==1)|(strcmp(checktag,'3dlines-')==1)|(strcmp(checktag,'2dlines-')==1);
                     fixhandles = [fixhandles 0];
                  else;
                     fixhandles = [fixhandles 1];
                  end;
               end;
               this_line = this_line(fixhandles==1);
            end;
            if size(this_line)==size(this_leg_line);
               for i=1:size(this_line,2);
                  set(this_line(1,i),'UserData',this_leg_line(1,i));
               end;
            end;
            this_leg_patch = sort(findobj(new_leg,'Type','patch')');
            this_patch = sort(findobj(new_ud.PlotHandle,'Type','patch')');
            if isempty(this_patch)==0;
               fixhandles = [];
               for j=1:size(this_patch,2);
                  checktag = get(this_patch(1,j),'Tag');
                  if size(checktag,2)>9;
                     checktag = checktag(1,1:9);
                  end;
                  if strcmp(checktag,'varpatch-')==1;
                     fixhandles = [fixhandles 0];
                  else;
                     fixhandles = [fixhandles 1];
                  end;
               end;
               this_patch = this_patch(fixhandles==1);
            end;
            if size(this_patch)==size(this_leg_patch);
               for i=1:size(this_patch,2);
                  set(this_patch(1,i),'UserData',this_leg_patch(1,i));
               end;
            end;
         end;
      end;
      %
      % update legend position information
      %
      if iscompiled==1;
         myaxes = get(toolbar.print,'UserData');
         if isempty(get(toolbar.edit,'UserData'))==0;
            all_leg_handles = [];
            for i=1:size(myaxes,2);
               new_leg_handle = get(myaxes(1,i),'UserData');
               if isempty(new_leg_handle)==0;
                  if ishandle(new_leg_handle)==1;
                     all_leg_handles = [all_leg_handles new_leg_handle];
                  end;
               end;
            end;
            thislegpos = [];
            for i=1:size(all_leg_handles,2);
               old_units = get(all_leg_handles(1,i),'Units');
               set(all_leg_handles(1,i),'Units','pixels');
               newlegpos = get(all_leg_handles(1,i),'Position');
               thislegpos = [thislegpos;newlegpos];
               set(all_leg_handles(1,i),'Units',old_units);
               set(toolbar.edit,'UserData',thislegpos);
            end;
         end;
      else;
         myfonts.legend = new_leg;
         set(this_axes,'UserData',myfonts);
      end;
   end;
end;

%
% end of change_legend_font.m
%
