function change_toolbar_fcn(myaxes)

%
% input is a 1xy vector, y=1,2,4 (typically)
%

curr_ini = find_inisettings;

psprintenable = 'off';
if strcmp(curr_ini.psprint,'')==0;
   fid = fopen(curr_ini.psprint,'rb');
   if fid>-1;
      fclose(fid);
      psprintenable = 'on';
   end;
end;

if curr_ini.box==1;
   boxstr = 'Hide Axes &Box';
else;
   boxstr = 'Show Axes &Box';
end;

h = get(myaxes(1,1),'Parent');
set(h,'DeleteFcn','drawnow');

mypos = get(h,'Position');
width = mypos(1,3);
height = mypos(1,4);

%
% legend handles (if any)
%

mylegs = [];
for i=1:size(myaxes,2);
   mylegs = [mylegs get(myaxes(1,i),'UserData')];
end;

if isempty(mylegs)==1;
   legenable = 'off';
   leg_str = 'Hide &Legend';
else;
   legenable = 'on';
   if strcmp(get(mylegs(1,1),'Visible'),'off')==1;
      leg_str = 'Show &Legend';
   else;
      leg_str = 'Hide &Legend';
   end;
end;

%
% surface objects (if any)
%

mysurf = [];
show_hide_surf = '';
for i=1:size(myaxes,2);
   %
   % Fix X-axis ticks if smaller than 1 and max is greater than 10
   %
   xtick = get(myaxes(1,i),'XTick');
   if size(xtick,2)>1;
      if (abs(max(xtick))>10)&(abs(min(xtick))>10);
         if xtick(1,2)-xtick(1,1)<1;
            min_xtick = ceil(min(get(myaxes(1,i),'XLim')));
            max_xtick = floor(max(get(myaxes(1,i),'XLim')));
            new_xtick = (min_xtick:1:max_xtick);
            set(myaxes(1,i),'XTick',new_xtick);
         end;
      end;
   end;
   %
   if curr_ini.ytick==1;
      fixytix(myaxes(1,i));
   end;
   if curr_ini.xtick==1;
      fixxtix(myaxes(1,i));
   end;
   %
   newsurf = findobj(myaxes(1,i),'Type','surface')';
   mysurf = [mysurf newsurf];
   fix_surf = [];
   if isempty(newsurf)==0;
      for j=1:size(newsurf,2);
         if isnumeric(get(newsurf(1,j),'UserData'))==1;
            if strcmp(get(newsurf(1,j),'Visible'),'on')==1;
               show_hide_surf = 'Hide &Plane';
               show_hide_ud = 1;
            else;
               show_hide_surf = 'Show &Plane';
               show_hide_ud = 0;
            end;
         else;
            fix_surf = [fix_surf newsurf(1,j)];
         end;
      end;
      if isempty(fix_surf)==1;
         show_hide_surf = '';
      end;
      newsurf = fix_surf;
   end;
end;

%
% remove any plane surfaces
%
if isempty(mysurf)==0;
   use_surf = [];
   for i=1:size(mysurf,2);
      if ischar(get(mysurf(1,i),'UserData'))==1;
         use_surf = [use_surf mysurf(1,i)];
      end;
   end;
   mysurf = use_surf;
end;

%
% button images
%

mycons = getstoredimages;
if curr_ini.use_toolbar_bgcolor==1;
   bgcolor = (1/255)*(round(255*get(0,'defaultuicontrolbackgroundcolor'))-[8 4 8]);
   bgcolor(1) = max(0,bgcolor(1));
   bgcolor(2) = max(0,bgcolor(2));
   bgcolor(3) = max(0,bgcolor(3));
else;
   bgcolor = [NaN NaN NaN];
end;
mysaveas = maketrans(mycons.saveas_image,[160 160 164],bgcolor);
myprintenable = maketrans(mycons.print_image,[160 160 164],bgcolor);
myfreehand = maketrans(mycons.editgraph_image,[160 160 164],bgcolor);
myrectangle = maketrans(mycons.rectangle_image,[160 160 164],bgcolor);
my_moviestar = maketrans(mycons.moviestar_image,[160 160 164],bgcolor);
%my_rec_movie_horizontal = maketrans(mycons.rec_movie_horizontal_image,[160 160 164],bgcolor);
%my_rec_movie_vertical = maketrans(mycons.rec_movie_vertical_image,[160 160 164],bgcolor);
myeditgraph = maketrans(mycons.axesproperties_image,[160 160 164],bgcolor);
myzoominup = maketrans(mycons.zoomin_image,[160 160 164],bgcolor);
myzoomoutup = maketrans(mycons.zoomout_image,[160 160 164],bgcolor);
my_text = maketrans(mycons.text_image,[160 160 164],bgcolor);
my_arrow = maketrans(mycons.arrow_image,[160 160 164],bgcolor);
my_line = maketrans(mycons.line_image,[160 160 164],bgcolor);
my_new = maketrans(mycons.new_image,[160 160 164],bgcolor);
my_viewgraphics = maketrans(mycons.open_image,[160 160 164],bgcolor);

if isempty(mysurf)==0;
   myrotate = maketrans(mycons.rotate_image,[160 160 164],bgcolor);
   myrotate3d_up = maketrans(mycons.rotate3d_image,[160 160 164],bgcolor);
end;

if ishandle(h)==1;
   set(h,'ResizeFcn','toolbar_resize_fcn');
   this_colorbar = findobj(h,'Type','axes','Tag','colorbar')';
   %
   % File menu
   %

   filemenu = uimenu('Parent',h, ...
      'Label','&File', ...
      'Tag','FileMenu');

   %
   % Objects on File menu
   %

   uimenu('parent',filemenu, ...
      'Label','&New Figure', ...
      'Callback','new_figure_fcn', ...
      'Enable','on', ...
      'Accelerator','F', ...
      'Tag','NewMenu');

   uimenu('parent',filemenu, ...
      'Label','&Open Figure...', ...
      'Callback','view_graphics_fcn', ...
      'Enable','on', ...
      'Accelerator','O', ...
      'Tag','OpenMenu');

   uimenu('Parent',filemenu, ...
      'Label','&Save As...', ...
      'Separator','on', ...
      'Callback','toolbar_saveas_fcn', ...
      'Enable','on', ...
      'Accelerator','S', ...
      'Tag','SaveAs');

   uimenu('Parent',filemenu, ...
      'Label','&Print', ...
      'Separator','on', ...
      'Accelerator','P', ...
      'Callback','toolbar_print_fcn', ...
      'Enable',psprintenable, ...
      'Tag','PrintMenu');

   if strcmp(computer,'PCWIN')==1;
      uimenu('Parent',filemenu, ...
         'Label','Prin&t Setup...', ...
         'Callback','uimenufcn(gcbf,''FilePrintSetup'')', ...
         'Enable',psprintenable, ...
         'Tag','PrintSetupMenu');
   end;

   uimenu('Parent',filemenu, ...
      'Label','Pa&ge Setup...', ...
      'Accelerator','G', ...
      'Callback','page_setup', ...
      'Enable','on', ...
      'Tag','PageSetupMenu');

   uimenu('Parent',filemenu, ...
      'Label','Pr&int Preview...', ...
      'Accelerator','I', ...
      'Callback','printpreview_fcn(gcf)', ...
      'Enable',psprintenable, ...
      'Tag','PrintPreviewMenu');

   uimenu('Parent',filemenu, ...
      'Label','&Close', ...
      'Separator','on', ...
      'Accelerator','C', ...
      'Callback','delete(gcf); drawnow', ...
      'Enable','on', ...
      'Tag','Close');

   %
   % Edit menu
   %

   editmenu = uimenu('Parent',h, ...
      'Label','&Edit', ...
      'Tag','EditMenu');

   %
   % Objects on edit menu
   %

   uimenu('Parent',editmenu, ...
      'Label','Ax&es Properties...', ...
      'Callback','toolbar_edit_fcn', ...
      'Accelerator','E', ...
      'Enable','on', ...
      'Tag','EditGraph');


   toolbar.name = uimenu('Parent',editmenu, ...
      'Label','&New Figure Name...', ...
      'Accelerator','W', ...
      'Callback','toolbar_name_fcn', ...
      'Enable','on', ...
      'Tag','NameMenu');


   toolbar.addmenu = uimenu('Parent',editmenu, ...
      'Separator','on', ...
      'Label','&Add', ...
      'Enable','on', ...
      'Tag','Add');

      toolbar.axesmenu = uimenu('Parent',toolbar.addmenu,'Label','A&xes','Accelerator','X','Callback','toolbar_addaxes_fcn');
      toolbar.freehandmenu = uimenu('Parent',toolbar.addmenu,'Label','&Draw Freehand','Accelerator','D','Callback','menu_freehand_fcn');
      if isempty(mysurf)==1;
         toolbar.rectanglemenu = uimenu('Parent',toolbar.addmenu,'Label','&Rectangle','Accelerator','R','Callback','menu_rectangle_fcn');
      end;
      toolbar.textmenu = uimenu('Parent',toolbar.addmenu,'Label','&Text','Accelerator','T','Callback','menu_addtext_fcn');
      toolbar.arrowmenu = uimenu('Parent',toolbar.addmenu,'Label','&Arrow','Accelerator','A','Callback','menu_addarrow_fcn');
      toolbar.linemenu = uimenu('Parent',toolbar.addmenu,'Label','&Line','Accelerator','L','Callback','menu_addline_fcn');

   toolbar.legend = uimenu('Parent',editmenu, ...
      'Separator','on', ...
      'Label',leg_str, ...
      'Accelerator','H', ...
      'Callback','toolbar_legend_fcn', ...
      'Enable',legenable, ...
      'Tag','LegendShow');

   toolbar.plotbox = uimenu('Parent',editmenu, ...
      'Label',boxstr, ...
      'Callback','toolbar_box_fcn', ...
      'Accelerator','B', ...
      'Enable','on', ...
      'Tag','PlotBox');

   %
   % Tools menu
   %

   toolsmenu = uimenu('Parent',h, ...
      'Label','&Tools', ...
      'Tag','ToolsMenu');

   %
   % Objects to Tools menu
   %

   toolbar.lock = uimenu('Parent',toolsmenu, ...
      'Label','Unloc&k Axes', ...
      'Accelerator','K', ...
      'Callback','toolbar_lock_fcn', ...
      'Enable','on', ...
      'Tag','LockType');

   toolbar.renderer = uimenu('Parent',toolsmenu, ...
      'Label','&Renderer', ...
      'Enable','on', ...
      'Tag','Renderer');

      painters_check = 'off';
      zbuffer_check = 'off';
      if strcmp(lower(get(h,'Renderer')),'painters')==1;
         painters_check = 'on';
      elseif strcmp(lower(get(h,'Renderer')),'zbuffer')==1;
         zbuffer_check = 'on';
      end;
      if (strcmp(painters_check,'on')==1)&(isempty(mysurf)==0);
         painters_check = 'off';
         zbuffer_check = 'on';
         set(h,'Renderer','zbuffer');
      elseif (strcmp(painters_check,'off')==1)&(strcmp(zbuffer_check,'off')==1);
         painters_check = 'on';
         set(h,'Renderer','painters');
      end;

   if (curr_ini.use_toolbar_bgcolor==1)&(strcmp(get(h,'Renderer'),'zbuffer')==1);
      figcolor = (1/255)*(round(255*get(0,'defaultuicontrolbackgroundcolor'))-[8 4 8]);
      figcolor(1) = max(0,figcolor(1));
      figcolor(2) = max(0,figcolor(2));
      figcolor(3) = max(0,figcolor(3));
   else;
      figcolor = get(0,'defaultuicontrolbackgroundcolor');
   end;
   set(h,'Color',figcolor);

      uimenu('Parent',toolbar.renderer, ...
         'Label','&Painters', ...
         'Checked',painters_check, ...
         'Enable','on', ...
         'Callback','toolbar_renderer_fcn', ...
         'Tag','painters');

      uimenu('Parent',toolbar.renderer, ...
         'Label','&Zbuffer', ...
         'Checked',zbuffer_check, ...
         'Enable','on', ...
         'Callback','toolbar_renderer_fcn', ...
         'Tag','zbuffer');

      toolbar.movies = uimenu('Parent',toolsmenu, ...
         'Label','Mo&vies', ...
         'Separator','on', ...
         'Enable','on', ...
         'Tag','MenuMovies3D');

      toolbar.menumovie = uimenu('Parent',toolbar.movies, ...
         'Label','&Show Movie', ...
         'Callback','movie_3d_fcn', ...
         'Enable','on', ...
         'Tag','MenuMovie3D');

   if isempty(mysurf)==0;

      toolbar.menurecordmovie_h = uimenu('Parent',toolbar.movies, ...
         'Label','&Record H-Movie', ...
         'Callback','record_3dmovie_fcn', ...
         'Separator','on', ...
         'Enable','on', ...
         'Tag','MenuRecord3DMovieHoriz');

      toolbar.menurecordmovie_v = uimenu('Parent',toolbar.movies, ...
         'Label','R&ecord V-Movie', ...
         'Callback','record_3dmovie_fcn(0)', ...
         'Enable','on', ...
         'Tag','MenuRecord3DMovieVert');

      uimenu('Parent',toolsmenu, ...
         'Label','Return &Original View', ...
         'Callback','toolbar_rotate_default_fcn', ...
         'Accelerator','R', ...
         'Separator','on', ...
         'Enable','on', ...
         'Tag','RotateDefaultView');

      if isempty(show_hide_surf)==0;
         toolbar.showhidesurface = uimenu('Parent',toolsmenu, ...
            'Label',show_hide_surf, ...
            'Callback','toolbar_show_hide_surface_fcn', ...
            'Enable','on', ...
            'UserData',show_hide_ud, ...
            'Tag','ShowHideSurface');
      end;

      if isempty(this_colorbar)==0;
         if strcmp(get(this_colorbar(1,1),'Visible'),'on')==1;
            toolbar.colorbar = uimenu('Parent',toolsmenu, ...
               'Label','&Hide Colorbar', ...
               'Callback','toolbar_colorbar_fcn', ...
               'Enable','on', ...
               'Tag','ColorBar');

            toolbar.deletecolorbar = uimenu('Parent',toolsmenu, ...
               'Label','&Delete Colorbar', ...
               'Callback','delete_colorbar_fcn', ...
               'Enable','on', ...
               'Tag','DeleteColorBar');
         else;
            toolbar.deletecolorbar = uimenu('Parent',toolsmenu, ...
               'Label','&Add Colorbar', ...
               'Callback','add_colorbar_fcn', ...
               'Enable','on', ...
               'Tag','DeleteColorBar');
         end;
      else;
         toolbar.deletecolorbar = uimenu('Parent',toolsmenu, ...
            'Label','&Add Colorbar', ...
            'Callback','toolbar_addcolorbar_fcn', ...
            'Enable','on', ...
            'Tag','DeleteColorBar');
      end;


   end;

   toolbar.hidden = uimenu('Parent',toolsmenu, ...
      'Label','&Show Hidden Lines', ...
      'Separator','on', ...
      'Callback','menu_show_hidden_fcn', ...
      'Enable','off', ...
      'Tag','MenuZoomIn');

   toolbar.menuzoomin = uimenu('Parent',toolsmenu, ...
      'Label','&Zoom In', ...
      'Separator','on', ...
      'Accelerator','Z', ...
      'Callback','menu_zoomin_fcn', ...
      'Enable','on', ...
      'Tag','MenuZoomIn');

   toolbar.menuzoomout = uimenu('Parent',toolsmenu, ...
      'Label','Zoo&m Out', ...
      'Callback','menu_zoomout_fcn', ...
      'Accelerator','M', ...
      'Enable','on', ...
      'Tag','MenuZoomOut');

   if isempty(mysurf)==0;

      toolbar.menurotate3d = uimenu('Parent',toolsmenu, ...
         'Label','Rotate &3D', ...
         'Callback','menu_rotate3d_fcn', ...
         'Accelerator','3', ...
         'Enable','on', ...
         'Tag','MenuRotate3D');

   end;

   %
   % Toolbar with axes background
   %


   toolbar.toolbar = uitoolbar('Parent',h, ...
                     'HandleVisibility','off', ...
                     'Interruptible','on', ...
                     'Clipping','on');

   %
   % x-axes lines
   %

   toolbar.box1 = xline([1 height-1 width],[0.5 1],curr_ini,h);

   %
   % New figure button
   %

   toolbar.new = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','New Figure', ...
                         'CData',my_new, ...
                         'ClickedCallback','new_figure_fcn', ...
                         'Separator','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','NewButton');

   %
   % Open figure button
   %

   toolbar.open = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Open Figure', ...
                         'CData',my_viewgraphics, ...
                         'ClickedCallback','view_graphics_fcn', ...
                         'Separator','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','OpenButton');

   if curr_ini.crop_image==1;
      set(toolbar.open,'UserData',1);
   end;

   %
   % save as button
   %

   toolbar.saveas = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Save As', ...
                         'CData',mysaveas, ...
                         'ClickedCallback','toolbar_saveas_fcn', ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData',0, ...
                         'Enable','on', ...
                         'Tag','SaveAsButton');

   %
   % print button
   %

   toolbar.print = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Print', ...
                         'CData',myprintenable, ...
                         'ClickedCallback','toolbar_print_fcn', ...
                         'Separator','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData',myaxes, ...
                         'Enable',psprintenable, ...
                         'Tag','PrintButton');

   toolbar.movie = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Show Movie', ...
                         'CData',my_moviestar, ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'ClickedCallback','movie_3d_fcn', ...
                         'Enable','on', ...
                         'Tag','MovieButton');


   %
   % Edit button
   %

   toolbar.edit = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Axes Properties', ...
                         'CData',myeditgraph, ...
                         'ClickedCallback','toolbar_edit_fcn', ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','EditButton');

   toolbar.freehand = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Draw Freehand', ...
                         'CData',myfreehand, ...
                         'ClickedCallback','toolbar_freehand_fcn', ...
                         'Separator','on', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','FreehandButton');

   if isempty(mysurf)==1;

      toolbar.rectangle = uitoggletool('Parent',toolbar.toolbar, ...
                            'TooltipString','Add Rectangle', ...
                            'CData',myrectangle, ...
                            'ClickedCallback','toolbar_rectangle_fcn', ...
                            'State','off', ...
                            'Interruptible','on', ...
                            'Clipping','on', ...
                            'Enable','on', ...
                            'Tag','RectangleButton');

   end;

   toolbar.addtext = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Add Text', ...
                         'CData',my_text, ...
                         'ClickedCallback','toolbar_addtext_fcn', ...
                         'Separator','off', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData','', ...
                         'Enable','on', ...
                         'Tag','AddTextButton');

   toolbar.addarrow = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Add Arrow', ...
                         'CData',my_arrow, ...
                         'ClickedCallback','toolbar_addarrow_fcn', ...
                         'Separator','off', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData',[], ...
                         'Enable','on', ...
                         'Tag','AddArrowButton');

   toolbar.addline = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Add Line', ...
                         'CData',my_line, ...
                         'ClickedCallback','toolbar_addline_fcn', ...
                         'Separator','off', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData',[], ...
                         'Enable','on', ...
                         'Tag','AddLineButton');

   addspace = 0;
   if isempty(mysurf)==0;

      addspace = 36;

      toolbar.rotate_default = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Return Original View', ...
                         'CData',myrotate, ...
                         'ClickedCallback','toolbar_rotate_default_fcn', ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','RotateDefaultButton');

      this_azel = [];
      for i=1:size(myaxes,2);
         this_azel = [this_azel;get(myaxes(1,i),'View')];
      end;

      set(toolbar.rotate_default,'UserData',this_azel);

   end;

   toolbar.zoomin = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Zoom In', ...
                         'CData',myzoominup, ...
                         'ClickedCallback','toolbar_zoomin_fcn', ...
                         'Separator','on', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'UserData','', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','ZoomInButton');

   toolbar.zoomout = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Zoom Out', ...
                         'CData',myzoomoutup, ...
                         'ClickedCallback','toolbar_zoomout_fcn', ...
                         'Separator','off', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'UserData','', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','ZoomOutButton');

   if isempty(mysurf)==0;

      toolbar.rotate3d = uitoggletool('Parent',toolbar.toolbar, ...
                            'TooltipString','Rotate 3D', ...
                            'CData',myrotate3d_up, ...
                            'ClickedCallback','toolbar_rotate3d_fcn', ...
                            'Separator','off', ...
                            'State','off', ...
                            'Interruptible','on', ...
                            'UserData','', ...
                            'Clipping','on', ...
                            'Enable','on', ...
                            'Tag','Rotate3dButton');

   end;

   set(h,'UserData',toolbar,...
      'HandleVisibility','callback',...
      'CloseRequestFcn','delete(get(0,''CurrentFigure'')); drawnow; drawnow');

end;

%
% end of change_toolbar_fcn.m
%
