function [autocorrvec,df] = lmautocorr(epsilon,Z0,Z1,Z2,beta,freq,t);

[n T] = size(epsilon);
if isempty(beta)==0;
   r = size(beta,2);
else;
   r = 0;
end;
H1 = [zeros(n,1) epsilon(:,1:T-1)];
if isempty(Z2)==0;
   H1 = [H1;Z2];
end;
if r>0;
   H1 = [H1;beta(:,1:r)'*Z1];
end;
Omega = (1/T)*epsilon*epsilon';
H2 = (1/T)*H1*H1';
H3 = (1/T)*Z0*H1';
M_00 = (1/T)*Z0*Z0';
%
Su = M_00-(H3*(H2\H3'));
LM1 = -(T-(size(Z1,1)+size(Z2,1)+r)-0.5)*(log(det(Su))-log(det(Omega)));

curr_ini = find_inisettings;

%
% create matrices for 1 year lag
%

if strcmp(freq,'')==0;
   if strcmp(freq,'q')==1;
      k = 4;
   else;
      k = 12;
   end;
   H1 = [zeros(n,k) epsilon(:,1:T-k)];
   if isempty(Z2)==0;
      H1 = [H1;Z2];
   end;
   if r>0;
      H1 = [H1;beta(:,1:r)'*Z1];
   end;
   H2 = (1/T)*H1*H1';
   H3 = (1/T)*Z0*H1';
   Su = M_00-(H3*(H2\H3'));
   LMk = -(T-(size(Z1,1)+size(Z2,1)+r)-0.5)*(log(det(Su))-log(det(Omega)));
end;

if curr_ini.sscorrect==0;
   autocorrvec = LM1;
   df = num2str(n*n);
   pval = chis_cdf(LM1,n*n);
   autocorrvec = [LM1 1-pval];
else;
   LM1 = ((t-n-1)/((T-1)*n*n))*LM1;
   autocorrvec = LM1;
   df = ['(' num2str(n*n) ',' num2str(t-1-n) ')'];
   pval = fdis_cdf(LM1,n*n,t-n-1);
   autocorrvec = [LM1 1-pval];
end;

if strcmp(freq,'')==0;
   if curr_ini.sscorrect==0;
      autocorrvec = [autocorrvec LMk];
      df = strvcat(df,num2str(n*n));
      pval = chis_cdf(LMk,n*n);
      autocorrvec = [autocorrvec 1-pval];
   else;
      LMk = ((t-n-k)/((T-k)*n*n))*LMk;
      autocorrvec = [autocorrvec LMk];
      df2 = ['(' num2str(n*n) ',' num2str(t-k-n) ')'];
      df = strvcat(df,df2);
      pval = fdis_cdf(LMk,n*n,t-n-k);
      autocorrvec = [autocorrvec 1-pval];
   end;
end;

%
% end of lmautocorr.m
%
