function [out,m_v,curr_ini,oldmodel_var] = main_close_fcn(out,m_v,curr_ini,button_images)

newinputfile = get(out.open,'UserData');
%
% Delete objects in file list
%
thish = findobj('Type','uimenu','Callback','maindlg reopen')';
if isempty(thish)==0;
   delete(thish);
end;
%
% recreate objects in file list menu
%
num = 1;
for i=1:size(m_v.reopenfile,1);
   thisfile = strtrim(m_v.reopenfile(i,:));
   if num==1;
      out.thisfile = uimenu('Parent',out.reopen, ...
         'Label',['&1. ' getfilename(thisfile)], ...
         'Callback','maindlg reopen', ...
         'Separator','on', ...
         'Accelerator','1', ...
         'UserData',thisfile, ...
         'Tag',['1-' getfilename(thisfile)]);
   else;
      if num<10;
         out.thisfile = uimenu('Parent',out.reopen, ...
            'Label',['&' num2str(num) '. ' getfilename(thisfile)], ...
            'Callback','maindlg reopen', ...
            'Accelerator',num2str(num), ...
            'UserData',thisfile, ...
            'Tag',[num2str(num) '-' getfilename(thisfile)]);
      else;
         out.thisfile = uimenu('Parent',out.reopen, ...
            'Label',['1&0. ' getfilename(thisfile)], ...
            'Callback','maindlg reopen', ...
            'Accelerator','0', ...
            'UserData',thisfile, ...
            'Tag',['10-' getfilename(thisfile)]);
      end;
   end;
   num = num+1;
end;
if strcmp(curr_ini.reopenlist,'')==1;
   set(out.reorderlist,'Enable','off');
else;
   set(out.reorderlist,'Enable','on');
end;
%
% Setting variables to default
%
m_v.endosheet = '';
m_v.exo1sheet = '';
m_v.exo0sheet = '';
m_v.detersheet = '';
m_v.spectest = [0 0 0 0];
m_v.modeltype = [1 0];
m_v.seasonal = [0 1];
m_v.freq = '';
m_v.runvar = 0;
m_v.newp = 1;
m_v.lagexo = 0;
m_v.newh = 40;
m_v.newc = 46;
m_v.endofile = pwd;
m_v.modelsdir = '';
m_v.exo1file = '';
m_v.exo0file = '';
m_v.deterfile = '';
m_v.cointvalue = 1;
m_v.nocointvalue = 0;
m_v.evars = '';
m_v.xvars1 = '';
m_v.xvars0 = '';
m_v.deter = '';
m_v.beginyear = '';
m_v.beginperiod = '';
m_v.endyear = '';
m_v.endperiod = '';
m_v.subbeginyear = '';
m_v.subbeginperiod = '';
m_v.subendyear = '';
m_v.subendperiod = '';
m_v.nameinput = '';
m_v.deterselect = [1 0 0 0];
m_v.scale_endo = 1;
m_v.shocks = '';
%
% Fix the scale variables controls
%
set(out.scale_1,'Check','off');
set(out.scale_2,'Check','off');
set(out.scale_3,'Check','off');
set(out.scale_4,'Check','off');
set(out.scale_5,'Check','on');
set(out.scale_6,'Check','off');
set(out.scale_7,'Check','off');
set(out.scale_8,'Check','off');
set(out.scale_9,'Check','off');
if m_v.newh>curr_ini.maxresp;
   m_v.newh = curr_ini.maxresp;
end;
m_v.basedir = m_v.modelsdir;
numchar = size(m_v.basedir,2);
if numchar>=1;
   m_v.basedir = m_v.basedir(1,1:numchar-1);
end;
i = numchar-1;
while i>=1;
   if strcmp(m_v.basedir(1,i),'\')==1;
      m_v.basedir = m_v.basedir(1,1:i-1);
      i = 0;
   elseif strcmp(m_v.basedir(1,i),'/')==1;
      m_v.basedir = m_v.basedir(1,1:i-1);
      i = 0;
   else;
      i = i-1;
   end;
end;
mypwd = pwd;
if strcmp(mypwd(1,1),'/')==1;
   m_v.inputfile = strcat(pwd,'/model.var');
   if curr_ini.dirstructure==1;
      m_v.outputfile = strcat(pwd,'/output.txt');
   else;
      m_v.outputfile = strcat(pwd,'/results/output.txt');
   end;
else;
   m_v.inputfile = strcat(pwd,'\model.var');
   if curr_ini.dirstructure==1;
      m_v.outputfile = strcat(pwd,'\output.txt');
   else;
      m_v.outputfile = strcat(pwd,'\results\output.txt');
   end;
end;
m_v.newdeterselect = m_v.deterselect;
m_v.newmodeltype = m_v.modeltype;
m_v.newseasonal = m_v.seasonal;
oldmodel_var = m_v;
modeldesc = getmodeldesc(m_v);
editorenable = 'off';
if fileexist(m_v.outputfile)==1;
   printenable = 'on';
   if strcmp(curr_ini.editor,'')==0;
      editorenable = 'on';
   else;
      editorenable = 'off';
   end;
else;
   printenable = 'off';
   if strcmp(curr_ini.editor,'')==0;
      editorenable = 'on';
   else;
      editorenable = 'off';
   end;
end;
%
% fixing menus
%
set(out.open,'UserData',m_v.inputfile);
set(out.exo1menu,'Enable','off');
set(out.exo0menu,'Enable','off');
set(out.determenu,'Enable','off');
set(out.editormenu,'Enable',editorenable);
set(out.savemenu,'Enable','off');
set(out.estimate,'Enable','off');
set(out.model_select,'Enable','off');
set(out.endonamesmenu,'Enable','off');
set(out.change_endonames,'Enable','off','CData',button_images.renamedisable);
set(out.exo1namesmenu,'Enable','off');
set(out.change_exo1names,'Enable','off','CData',button_images.renamedisable);
set(out.exogenous1text,'String','Exogenous I(1) variables:  None');
set(out.exo0namesmenu,'Enable','off');
set(out.change_exo0names,'Enable','off','CData',button_images.renamedisable);
set(out.exogenous0text,'String','Exogenous I(1) variables:  None');
set(out.deternamesmenu,'Enable','off');
set(out.change_deternames,'Enable','off','CData',button_images.renamedisable);
set(out.deterministictext,'String','Deterministic variables:  None');
set(out.endographicsmenu,'Enable','off');
set(out.exo1graphicsmenu,'Enable','off');
set(out.exo0graphicsmenu,'Enable','off');
set(out.detergraphicsmenu,'Enable','off');
set(out.store,'Enable','off');
set(out.run,'Enable','off');
set(out.endogenoustext,'String','Endogenous variables:  None');
set(out.endonames,'Enable','off','UserData','');
set(out.exo1names,'Enable','off','UserData','');
set(out.exo0names,'Enable','off','UserData','');
set(out.deternames,'Enable','off','UserData','');
set(out.printpreview,'Enable',printenable);
set(out.print,'Enable',printenable);
set(out.printmenu,'Enable',printenable);
set(out.printpreviewmenu,'Enable',printenable);
if strcmp(printenable,'on')==1;
   if islatexformat(m_v.outputfile)==1;
      stat_dvi = check_dvi(curr_ini);
      if stat_dvi==0;
         set(out.dvimenu,'Enable','on');
      else;
         set(out.dvimenu,'Enable','off');
      end;
      [stat_ps,dvips] = check_ps(curr_ini);
      if stat_ps==0;
         set(out.psmenu,'Enable','on');
      else;
         set(out.psmenu,'Enable','off');
      end;
      [stat_pdf,prog_seq] = check_pdf(curr_ini);
      if stat_pdf==0;
         set(out.pdfmenu,'Enable','on');
      else;
         set(out.pdfmenu,'Enable','off');
      end;
   else;
      set(out.dvimenu,'Enable','off');
      set(out.psmenu,'Enable','off');
      set(out.pdfmenu,'Enable','off');
   end;
else;
   set(out.dvimenu,'Enable','off');
   set(out.psmenu,'Enable','off');
   set(out.pdfmenu,'Enable','off');
end;
set(out.structural,'Enable','off','Value',1);
set(out.reduced,'Enable','off','Value',0);
set(out.endogenous,'String',m_v.endofile,'UserData',m_v.modelsdir);
set(out.exogenous1text,'Enable','off');
set(out.exogenous1,'String',m_v.exo1file);
if strcmp(get(out.exogenous1,'Type'),'uicontrol')==1;
   set(out.exogenous1,'Enable','off','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
else;
   editbox(out.exogenous1,'Enable','off','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
end;
set(out.exo1button,'Enable','off','CData',button_images.browsedisable);
set(out.exogenous0text,'Enable','off');
set(out.exogenous0,'String',m_v.exo0file);
if strcmp(get(out.exogenous0,'Type'),'uicontrol')==1;
   set(out.exogenous0,'Enable','off','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
else;
   editbox(out.exogenous0,'Enable','off','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
end;
set(out.exo0button,'Enable','off','CData',button_images.browsedisable);
set(out.deterministictext,'Enable','off');
set(out.deterministic,'String',m_v.deterfile);
if strcmp(get(out.deterministic,'Type'),'uicontrol')==1;
   set(out.deterministic,'Enable','off','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
else;
   editbox(out.deterministic,'Enable','off','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
end;
set(out.deterbutton,'Enable','off','CData',button_images.browsedisable);
%
set(out.endosheettext,'String','Data sheet: None');
set(out.exo1sheettext,'String','Data sheet: None');
set(out.exo0sheettext,'String','Data sheet: None');
set(out.detersheettext,'String','Data sheet: None');
%
set(out.outputfile,'String',m_v.outputfile);
set(out.beginyear,'Enable','off','String','','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
set(out.beginperiod,'Enable','off','String','','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
set(out.endyear,'Enable','off','String','','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
set(out.endperiod,'Enable','off','String','','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
set(out.subbeginyear,'Enable','off','String','','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
set(out.subbeginperiod,'Enable','off','String','','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
set(out.subendyear,'Enable','off','String','','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
set(out.subendperiod,'Enable','off','String','','BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'));
set(out.sample,'Enable','off');
set(out.subsample,'Enable','off');
set(out.text,'String',modeldesc);
set(out.mypopuptext,'Enable','off');
set(out.mypopup,'Enable','off','Value',m_v.newp);
set(out.mypopuphtext,'Enable','off');
set(out.lagexo,'Enable','off','Value',m_v.lagexo+1);
set(out.lagexotext,'Enable','off');
set(out.mypopuph,'Enable','off','Value',m_v.newh);
set(out.mypopupctext,'Enable','off');
set(out.mypopupc,'Enable','off','Value',m_v.newc);
set(out.radiocoint,'Enable','off','Value',m_v.cointvalue);
set(out.radionocoint,'Enable','off','Value',m_v.nocointvalue);
set(out.uconstant,'Enable','off','Value',1,'UserData',1);
set(out.rconstant,'Enable','off','Value',0,'UserData',2);
set(out.utrend,'Enable','off','Value',0,'UserData',3);
set(out.rtrend,'Enable','off','Value',0,'UserData',4);
set(out.seasonal,'Enable','off','Value',m_v.seasonal(1,1),'UserData',m_v.freq);
set(out.noseasonal,'Enable','off','Value',m_v.seasonal(1,2));
set(out.serial,'Enable','off','Value',0);
set(out.arch,'Enable','off','Value',0);
set(out.normality,'Enable','off','Value',0);
set(out.constancy,'Enable','off','Value',0);
set(out.clear,'Enable','off');
set(out.close,'Enable','off');
ud = get(out.statusbar,'UserData');
ud.string = ['Structural VAR, version ' num2str(myvers,'%0.2f')];
set(out.statusbar,'String',ud.string,'UserData',ud);

%
% end of main_close_fcn.m
%
