function [pos,spec_ploti] = pq_plot(pos,fig_tag,fig_name,p1_title,p2_title,p3_title,p4_title,tm,as_quant,as_table,p_series,pp_series,qq_series,col)

%
% 2x2 plots of p-value plot, p-value discrepancy plot,
% pp plot, and qq plot
%

spec_ploti = figure('Units','pixels', ...
   'Position',[pos-[0 100] 700 500], ...
   'Menubar','none', ...
   'Toolbar','none', ...
   'NumberTitle','off', ...
   'Tag',fig_tag, ...
   'Visible','off', ...
   'Name',fig_name);
%
pos = [pos(1)+22 pos(2)-22];
if pos(1,1)>(tm.realscrsz(3)-600);
   pos = [0 tm.realscrsz(4)-470];
end;
if pos(1,2)>(tm.realscrsz(4)-470);
   pos = [0 tm.realscrsz(4)-470];
elseif pos(1,2)<32;
   pos = [0 tm.realscrsz(4)-470];
end;
%
% obey centering and filling defaults
%
setfigureproperties(spec_ploti);
%
subplot(2,2,1);
plot([0 1],[0 1],'-','LineWidth',1,'Color',[0 0 0]);
hold('on');
plot(as_quant,p_series,'-','LineWidth',1,'Color',col.vec_2,'Tag','p-value-plot');
set(gca,'XLim',[0 1],'YLim',[0 1]);
setaxesfonts('Title',p1_title,'XLabel','Nominal Size','YLabel','Actual Size (p-value)');
axeshandles = gca;
hold('off');
%
subplot(2,2,2);
plot([0 1],[0 0],'-','LineWidth',1,'Color',[0 0 0]);
hold('on');
plot(as_quant,p_series-as_quant,'-','LineWidth',1,'Color',col.vec_2,'Tag','p-value-disc-plot');
set(gca,'XLim',[0 1],'YLim',[-1 1]);
setaxesfonts('Title',p2_title,'XLabel','Nominal Size','YLabel','Size Difference');
axeshandles = [axeshandles gca];
hold('off');
%
subplot(2,2,3);
plot([0 1],[0 1],'-','LineWidth',1,'Color',[0 0 0]);
hold('on');
plot(as_quant,pp_series,'-','LineWidth',1,'Color',col.vec_2,'Tag','pp-plot');
set(gca,'XLim',[0 1],'YLim',[0 1]);
setaxesfonts('Title',p3_title,'XLabel','Nominal Size','YLabel','Actual Size (Test)');
axeshandles = [axeshandles gca];
hold('off');
%
subplot(2,2,4);
plot([0 max(as_table(221,1),qq_series(221,1))],[0 max(as_table(221,1),qq_series(221,1))],'-','LineWidth',1,'Color',[0 0 0]);
hold('on');
plot(as_table,qq_series,'-','LineWidth',1,'Color',col.vec_2,'Tag','qq-plot');
set(gca,'XLim',[0 max(as_table(221,1),qq_series(221,1))],'YLim',[0 max(as_table(221,1),qq_series(221,1))]);
setaxesfonts('Title',p4_title,'XLabel','Asymptotic Quantiles','YLabel','Bootstrap Quantiles');
axeshandles = [axeshandles gca];
hold('off');
toolbar_fcn(axeshandles);

%
% end of pq_plot.m
%
