function print_nyblom(tm,curr_ini)

old_restrict = tm.restrict;
if size(tm.restrict,2)==2;
   tm.restrict = [0 1];
end;
[nyblomT,nyblomcorr,evaluet,tT] = nyblom_restbeta_fcn(tm,curr_ini,tm.cointbeta,tm.Z0,tm.Z1,tm.Z2,tm.T,tm.r,tm.T);
meannT = (1/size(nyblomT,2))*sum(nyblomT);
nyblomT = max(nyblomT);
datet = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,1));
dateT = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,size(tT,2)));

%
% print results to output-file
%

fout = fopen(tm.outputfile,'at');
if curr_ini.texoutputformat>=2;
   fprintf(fout,'\\header{Nyblom tests for $\\beta$}\n\n');
   fprintf(fout,'\\begin{tabular}{ll}\n');
   fprintf(fout,'$H_0$: & $\\beta$ is constant \\\\\n');
   fprintf(fout,'$H_A$: & $\\beta$ is not constant \\\\[2mm]\n');
   fprintf(fout,[' & $\\sup_{t \\in \\{\\mbox{\\rm {\\footnotesize %s}}, \\ldots ,\\mbox{\\rm {\\footnotesize %s}}\\}} Q_{t|T}(\\mbox{\\rm \\#endo vars}=%0.0f,r=%0.0f)$ = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],datet,dateT,tm.n,tm.r,nyblomT(1,1));
   fprintf(fout,[' & $\\mean_{t \\in \\{\\mbox{\\rm {\\footnotesize %s}}, \\ldots ,\\mbox{\\rm {\\footnotesize %s}}\\}} Q_{t|T}(\\mbox{\\rm \\#endo vars}=%0.0f,r=%0.0f)$ = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],datet,dateT,tm.n,tm.r,meannT);
   fprintf(fout,'\\end{tabular}\n\n');
   fprintf(fout,'\\ruler\n\n%%==============================================================================\n\n');
else;
   fprintf(fout,'  Nyblom tests for beta\n');
   fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~\n\n');
   fprintf(fout,'Null hypothesis:        beta is constant\n');
   fprintf(fout,'Alternative hypothesis: beta is not constant\n\n');
   fprintf(fout,['sup_{t=%s,...,%s} Q(t|T=%s;endo vars=%1.0f,rank=%1.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n\n'],datet,dateT,dateT,tm.n,tm.r,nyblomT(1,1));
   fprintf(fout,['Mean Q(t|T=%s;endo vars=%1.0f,rank=%1.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n\n'],dateT,tm.n,tm.r,meannT);
   fprintf(fout,'===============================================================================\n\n');
end;
fclose(fout);

tm.restrict = old_restrict;

%
% end of print_nyblom.m
%
