function [W,stat] = altwish_rnd(sigma,v,cu_symmetric)

if nargin==2;
   cu_symmetric = 0;
end;

q = size(sigma,1);

[S,stat] = chol(sigma);
if stat>0;
   W = [];
   return;
end;

%
% set the random number generator state
%
randn('state',sum(100*clock));
z = randn(q,q);
y = gamrnd_fcn( (v-(1:q))/2,2);

b = NaN*sigma ;

% first element
b(1,1) = y(1) ;
if q>1;
   % rest of diagonal
   for j=2:q;
      zz = z(1:(j-1),j);
      b(j,j) = y(j)+(zz'*zz);
   end;
   %first row and column
   for j=2:q;
      b(1,j) = z(1,j)*sqrt(y(1));
      b(j,1) = b(1,j);
   end;
end;
if q>2;
   for j=3:q;
      for i=2:(j-1);
         ix = 1:(i-1);
         zki = z(ix,i);
         zkj = z(ix,j);
         b(i,j) = (z(i,j)*sqrt(y(i)))+(zki'*zkj);
         b(j,i) = b(i,j);
      end;
   end;
end;

S = S';
if cu_symmetric==1;
   S = symm(sigma);
end;

W = S*b*S';

%
% end of altwish_rnd.m
%
