function [w,stat] = invwish_rnd(sigma,v,cu_symmetric)

%
% Delivers a draw from the inverted Wishart Distribution with parameters sigma and v.
%
% The "cu_symmetric" parameter is optional and allows for a symmetric decomposition of
% sigma rather than a Choleski decomposition.
%

if nargin==2;
   cu_symmetric = 0;
end;

q = size(sigma,1);
%
% first decompose sigma
%

[S,stat] = chol(sigma);
if stat>0;
   w = [];
   return;
end;
%

[W,stat] = altwish_rnd(inverse(S),v,cu_symmetric);

if stat==0;
   w = inverse(W) ;
else;
   w = [];
end;


%
% end of invwish_rnd.m
%
