function resize_legend(legh)
%RESIZE_LEGEND Resize all legend in this figure

ud = get(legh,'userdata');
units = get(legh,'units');
set(legh,'units','normalized')

if ~isfield(ud,'LegendPosition')
  warning('No legend to update.')
  hl = []; objh = [];
  return
end

moved = DidLegendMove(legh);

set(legh,'units','points')
oldpos = get(legh,'position');

% Update the legend
if moved | length(ud.legendpos)==4
  [hl,objh] = make_legend(legh,ud.PlotHandle,ud.handles,ud.lstrings,oldpos,ud);
else
  [hl,objh] = make_legend(legh,ud.PlotHandle,ud.handles,ud.lstrings,ud.legendpos,ud);
end
set(hl,'units',units)

%
% end of resize_legend.m
%
