function [test,deg_free,pval,phi,phi_std,kappa,kappa_std,delta,delta_std,abort] = proportionality_dummies(epsilon,Z0,Z1,Z2,alpha,beta,Psi,restrict,sel_dummies,num_const,num_dummies,p,pe,q1,q0,df,dcoint,modelsdir,modelfile,convcrit,maxit,reestbeta,sscorrect)

test = 0;
pval = 0;
deg_free = zeros(1,1+sscorrect);
phi = [];
kappa = [];
phi_std = [];
kappa_std = [];
delta = [];
delta_std = [];
[n T] = size(epsilon);
t = T-df;
%
% compute log-likelihood under the alternative
%
lnL_orig = loglike(epsilon);
%
% setting up the data
%
D = Z2(num_const+sel_dummies,:);
keep_z2 = setdiff((1:1:size(Z2,1)),num_const+sel_dummies);
if isempty(keep_z2)==0;
   Z2_new = Z2(keep_z2,:);
   Psi = Psi(:,keep_z2);
else;
   Z2_new = [];
   Psi = [];
end;
%
% determine d, the number of unrestricted deterministic variables
%
d = num_const+(num_dummies-size(sel_dummies,2));
%
% run the estimation routine
%
[alpha,beta,Psi,phi,kappa,epsilon_n,info_mat,k_orth,abort] = estimate_proportionality(Z0,Z1,Z2_new,D,epsilon,p,pe,d,q1,q0,dcoint,alpha,beta,Psi,modelsdir,modelfile,convcrit,maxit,reestbeta,restrict,1);

if strcmp(abort,'cancel')==0;
   lnL_h0 = loglike(epsilon_n);
   test = 2*(lnL_orig-lnL_h0);
   if sscorrect==0;
      deg_free = (n*size(sel_dummies,2))-(n+(size(sel_dummies,2)-1));
      pval = 1-chis_cdf(test,deg_free);
   else;
      deg_free(1,1) = (n*size(sel_dummies,2))-(n+(size(sel_dummies,2)-1));
      deg_free(1,2) = t+floor(deg_free(1,1)/n)-1;
      test = (deg_free(1,2)/(T*deg_free(1,1)))*test;
      pval = 1-fdis_cdf(test,deg_free(1,1),deg_free(1,2));
   end;
   phi_std = sqrt(diag(info_mat(1:n,1:n)));
   psi_vcv = info_mat(n+1:n+size(k_orth,2),n+1:n+size(k_orth,2));
   kappa_std = sqrt(diag(k_orth*psi_vcv*k_orth'));
   %
   % now we go for the delta parameters, where delta = phi*kappa'
   %
   delta = phi*kappa';
   %
   % the linearization
   %
   lin_mat = [kron(kappa,eye(n)) kron(k_orth,phi)];
   delta_std = sqrt(diag(lin_mat*info_mat(1:n+size(k_orth,2),1:n+size(k_orth,2))*lin_mat'));
   delta_std = vecinv(delta_std,n);
end;

%
% end of proportionality_dummies.m
%
