function show_gctest(fig_handle,beta,alpha,Psi,Sigma_theta,tm,curr_ini,ind,aind)

set(fig_handle,'Visible','off');
drawnow;
%
res_str = '';
if ind==1;
   res_str = ' restricted';
end;
realscrsz = get(0,'ScreenSize');
c_ind = 0;
if size(tm.restrict,2)==3;
   c_ind = tm.restrict(1,3);
end;
sp_str = spacestr(curr_ini.decimals-2);
%
[results,dfmat] = waldgctest(Psi,alpha,beta,tm.p,tm.pe,tm.epsilon,tm.Z1,tm.Z2,tm.q1,tm.q0,tm.d,tm.T-tm.df,aind,tm.modelsdir,tm.modelfile,Sigma_theta,c_ind);
gctext = strvcat(' ',['GRANGER CAUSALITY TESTS (for' res_str ' rank=' num2str(tm.r,'%1.0f') ')']);
numchar = size(gctext,2);
addcorr = '';
for i=1:numchar;
   addcorr = strcat(addcorr,'=');
end;
gctext = strvcat(gctext,addcorr,' ');
gctext = strvcat(gctext,'  Wald-type test statistic','  ~~~~~~~~~~~~~~~~~~~~~~~~');
sumnk = 0;
for i=1:tm.n;
   vari = strrep(tm.myvars(i,:),' ','');
   gctext = strvcat(gctext,' ',['Null Hypothesis:        var. k is Granger noncausal for ' vari]);
   gctext = strvcat(gctext,['Alternative Hypothesis: var. k is Granger causal for ' vari],' ');
   if curr_ini.sscorrect==0;
      gctext = strvcat(gctext,[' k             W   ' sp_str '   df     p-value']);
   else;
      gctext = strvcat(gctext,[' k             F   ' sp_str '      df        p-value']);
   end;
   for k=1:tm.n;
      if isequal(i,k)==0;
         sumnk = sumnk+1;
         if curr_ini.sscorrect==0;
            if dfmat(sumnk,1)>0;
               out = sprintf([' %s        %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f     %2.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(k,:),results(sumnk,1),dfmat(sumnk,1),results(sumnk,2));
               gctext = strvcat(gctext,out);
            else;
               gctext = strvcat(gctext,[' ' tm.myvars(k,:) '        Not computed']);
            end;
         else;
            if dfmat(sumnk,1)>0;
               out = sprintf([' %s        %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f     (%2.0f,%3.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(k,:),results(sumnk,1),dfmat(sumnk,1),dfmat(sumnk,2),results(sumnk,2));
               gctext = strvcat(gctext,out);
            else;
               gctext = strvcat(gctext,[' ' tm.myvars(k,:) '        Not computed']);
            end;
         end;
      end;
   end;
   if i<tm.n;
      gctext = strvcat(gctext,' ','~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~');
   else;
      gctext = strvcat(gctext,' ');
   end;
end;
textgui(gctext,'Granger Causality Tests',[(realscrsz(3)-680)/2 (realscrsz(4)-400)/2 680 400],'Results',38);
set(fig_handle,'Visible','on');
drawnow;

%
% end of show_gctest.m
%
