function toolbar_fcn(myaxes,show_light)

if nargin==1;
   show_light = 'off';
end;

%h = get(0,'CurrentFigure');
h = get(myaxes(1,1),'Parent');
set(h,'Menubar','figure','Toolbar','auto','DeleteFcn','drawnow','CloseRequestFcn','delete(gcf)');
curr_ini = find_inisettings;

%
% objects (if any)
%

mylines = [];
mypatches = [];
myleg_lines = [];
x_zeros = zeros(size(myaxes));
for i=1:size(myaxes,2);
   this_axes(i).surface = sort(findobj(myaxes(1,i),'Type','surface')');
   %
   % looking for lines
   %
   linehandles = findobj(myaxes(1,i),'Type','line')';
   delhandles = [];
   if isempty(linehandles)==0;
      %
      % Remove zero lines from linehandles
      %
      fixhandles = [];
      for j=1:size(linehandles,2);
         checkvec = get(linehandles(1,j),'YData');
         checkvec2 = sum(get(linehandles(1,j),'XData'));
         checkstyle = get(linehandles(1,j),'LineStyle');
         if ((checkvec==zeros(size(checkvec,1),1))|(checkvec2==zeros(size(checkvec2,1),1)))&((strcmp(checkstyle,'none')==0)|(isempty(get(linehandles(1,j),'UserData'))==0))|(strcmp(get(linehandles(1,j),'Tag'),'light')==1);
            fixhandles = [fixhandles 0];
         else;
            fixhandles = [fixhandles 1];
         end;
         if checkvec==zeros(size(checkvec,1),1);
            x_zeros(1,i) = 1;
         end;
      end;
      delhandles = linehandles(fixhandles==0);
      linehandles = linehandles(fixhandles==1);
      if (size(linehandles,1)==0)|(size(linehandles,2)==0);
         linehandles = [];
      end;
   end;
   if isempty(linehandles)==0;
      myleg_lines = [myleg_lines findobj(get(myaxes(1,i),'UserData'),'Type','line')'];
   end;
   legendline = [];
   if isempty(get(myaxes(1,i),'UserData'))==0;
      legendline = findobj(get(myaxes(1,i),'UserData'),'Type','line')';
   end;
   this_axes(1,i).ud = get(get(myaxes(1,i),'UserData'),'UserData');
   this_axes(1,i).legendline = legendline;
   this_axes(1,i).line = linehandles;
   mylines = [mylines linehandles];
   patchhandles = findobj(myaxes(1,i),'Type','patch')';
   this_axes(1,i).patch = patchhandles;
   patchleg = [];
   if isempty(patchhandles)==0;
      patchleg = findobj(get(myaxes(1,i),'UserData'),'Type','patch')';
      this_axes(1,i).legendpatch = patchleg;
   end;
   mypatches = [mypatches patchhandles];
   if curr_ini.ytick==1;
      fixytix(myaxes(1,i));
   end;
   if curr_ini.xtick==1;
      fixxtix(myaxes(1,i));
   end;
end;

b_lh = 0;
this_colorbar = findobj(h,'Type','axes','Tag','colorbar')';
for i=1:size(myaxes,2);
   if strcmp(get(myaxes(1,i),'Tag'),'colorbar')==0;
      %
      % create a context menu for axes objects
      %
      axes_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
         uimenu('Parent',axes_context_menu,'Label','Font','Callback','change_axes_font');
         uimenu('Parent',axes_context_menu,'Separator','on','Label','Background Color','Callback','change_axes_color');
      axes_color_menu = uimenu('Parent',axes_context_menu,'Label','Axes Color');
         uimenu('Parent',axes_color_menu,'Label','Axes Color','Callback','change_allaxes_color');
         uimenu('Parent',axes_color_menu,'Label','X Axis Color','Callback','change_xaxes_color');
         uimenu('Parent',axes_color_menu,'Label','Y Axis Color','Callback','change_yaxes_color');
      axes_width_menu = uimenu('Parent',axes_context_menu,'Label','Axes Width');
         pt0 = 'off';
         pt1 = 'off';
         pt2 = 'off';
         pt3 = 'off';
         pt4 = 'off';
         pt5 = 'off';
         pt6 = 'off';
         pt7 = 'off';
         pt8 = 'off';
         pt9 = 'off';
         pt10 = 'off';
         if get(myaxes(1,i),'LineWidth')==0.5;
            pt0 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==1;
            pt1 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==2;
            pt2 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==3;
            pt3 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==4;
            pt4 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==5;
            pt5 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==6;
            pt6 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==7;
            pt7 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==8;
            pt8 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==9;
            pt9 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==10;
            pt10 = 'on';
         end;
         uimenu('Parent',axes_width_menu,'Label','0.5 pt','Checked',pt0,'Callback','set(gca,''LineWidth'',0.5); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','1 pt','Checked',pt1,'Callback','set(gca,''LineWidth'',1); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','2 pts','Checked',pt2,'Callback','set(gca,''LineWidth'',2); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','3 pts','Checked',pt3,'Callback','set(gca,''LineWidth'',3); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','4 pts','Checked',pt4,'Callback','set(gca,''LineWidth'',4); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','5 pts','Checked',pt5,'Callback','set(gca,''LineWidth'',5); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','6 pts','Checked',pt6,'Callback','set(gca,''LineWidth'',6); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','7 pts','Checked',pt7,'Callback','set(gca,''LineWidth'',7); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','8 pts','Checked',pt8,'Callback','set(gca,''LineWidth'',8); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','9 pts','Checked',pt9,'Callback','set(gca,''LineWidth'',9); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','10 pts','Checked',pt10,'Callback','set(gca,''LineWidth'',10); check_axes_lines; uimenu_check_fcn');
      axes_grid_menu = uimenu('Parent',axes_context_menu,'Label','Grid Style');
         pt1 = 'off';
         pt2 = 'off';
         pt3 = 'off';
         pt4 = 'off';
         pt5 = 'off';
         if strcmp(get(myaxes(1,i),'GridLineStyle'),'-')==1;
            pt1 = 'on';
         elseif strcmp(get(myaxes(1,i),'GridLineStyle'),'--')==1;
            pt2 = 'on';
         elseif strcmp(get(myaxes(1,i),'GridLineStyle'),':')==1;
            pt3 = 'on';
         elseif strcmp(get(myaxes(1,i),'GridLineStyle'),'-.')==1;
            pt4 = 'on';
         elseif strcmp(get(myaxes(1,i),'GridLineStyle'),'none')==1;
            pt5 = 'on';
         end;
         uimenu('Parent',axes_grid_menu,'Label','Solid','Checked',pt1,'Callback','set(gca,''GridLineStyle'',''-''); uimenu_check_fcn');
         uimenu('Parent',axes_grid_menu,'Label','Dash','Checked',pt2,'Callback','set(gca,''GridLineStyle'',''--''); uimenu_check_fcn');
         uimenu('Parent',axes_grid_menu,'Label','Dot','Checked',pt3,'Callback','set(gca,''GridLineStyle'','':''); uimenu_check_fcn');
         uimenu('Parent',axes_grid_menu,'Label','Dash-Dot','Checked',pt4,'Callback','set(gca,''GridLineStyle'',''-.''); uimenu_check_fcn');
         uimenu('Parent',axes_grid_menu,'Label','None','Checked',pt5,'Callback','set(gca,''GridLineStyle'',''none''); uimenu_check_fcn');
      axes_tick_menu = uimenu('Parent',axes_context_menu,'Label','Tick Direction');
         if strcmp(get(myaxes(1,i),'TickDir'),'in')==1;
            uimenu('Parent',axes_tick_menu,'Label','In','Checked','on','Callback','set(gca,''TickDir'',''in''); uimenu_check_fcn');
            uimenu('Parent',axes_tick_menu,'Label','Out','Checked','off','Callback','set(gca,''TickDir'',''out''); uimenu_check_fcn');
         else;
            uimenu('Parent',axes_tick_menu,'Label','In','Checked','off','Callback','set(gca,''TickDir'',''in''); uimenu_check_fcn');
            uimenu('Parent',axes_tick_menu,'Label','Out','Checked','on','Callback','set(gca,''TickDir'',''out''); uimenu_check_fcn');
         end;
      axes_layer_menu = uimenu('Parent',axes_context_menu,'Label','Layer');
         if strcmp(get(myaxes(1,i),'Layer'),'bottom')==1;
            uimenu('Parent',axes_layer_menu,'Label','Bottom','Checked','on','Callback','set(gca,''Layer'',''bottom''); uimenu_check_fcn');
            uimenu('Parent',axes_layer_menu,'Label','Top','Checked','off','Callback','set(gca,''Layer'',''top''); uimenu_check_fcn');
         else;
            uimenu('Parent',axes_layer_menu,'Label','Bottom','Checked','off','Callback','set(gca,''Layer'',''bottom''); uimenu_check_fcn');
            uimenu('Parent',axes_layer_menu,'Label','Top','Checked','on','Callback','set(gca,''Layer'',''top''); uimenu_check_fcn');
         end;
      %
      if isempty(this_axes(i).surface)==0;
         set(h,'Renderer','zbuffer');
         uimenu('Parent',axes_color_menu,'Label','Z Axis Color','Callback','change_zaxes_color');
         axes_projection_menu = uimenu('Parent',axes_context_menu,'Label','Projection');
         if strcmp(get(myaxes(1,i),'Projection'),'orthographic')==1;
            uimenu('Parent',axes_projection_menu,'Label','Orthographic','Checked','on','Callback','change_axes_projection');
            uimenu('Parent',axes_projection_menu,'Label','Perspective','Checked','off','Callback','change_axes_projection');
         else;
            uimenu('Parent',axes_projection_menu,'Label','Orthographic','Checked','off','Callback','change_axes_projection');
            uimenu('Parent',axes_projection_menu,'Label','Perspective','Checked','on','Callback','change_axes_projection');
         end;
         uimenu('Parent',axes_context_menu,'Label','Ambient Light Color','Separator','on','Callback','change_ambientlight_color');
         uimenu('Parent',axes_context_menu,'Label','Light Color','Callback','change_light_color');
         axes_lightstyle_menu = uimenu('Parent',axes_context_menu,'Label','Light Style');
         my_light = findobj(myaxes(1,i),'Type','light')';
         if strcmp(get(my_light,'Style'),'infinite')==1;
            uimenu('Parent',axes_lightstyle_menu,'Label','Infinite','Checked','on','Callback','change_light_style');
            uimenu('Parent',axes_lightstyle_menu,'Label','Local','Checked','off','Callback','change_light_style');
         else;
            uimenu('Parent',axes_lightstyle_menu,'Label','Infinite','Checked','off','Callback','change_light_style');
            uimenu('Parent',axes_lightstyle_menu,'Label','Local','Checked','on','Callback','change_light_style');
         end;
         light_pos = get(my_light,'Position');
         light_line = findobj(myaxes(1,i),'Type','line','UserData','light')';
         if isempty(light_line)==1;
            light_line = line('XData',light_pos(1), ...
                            'YData',light_pos(2), ...
                            'ZData',light_pos(3), ...
                            'Parent',myaxes(1,i), ...
                            'UserData','light', ...
                            'Tag','light', ...
                            'Visible',show_light, ...
                            'LineStyle','-', ...
                            'LineWidth',1, ...
                            'Marker','o', ...
                            'MarkerEdgeColor',get(myaxes(1,i),'AmbientLightColor'), ...
                            'MarkerFaceColor',get(my_light,'Color'), ...
                            'MarkerSize',10);
            %
            % Link a context menu to the light_line object
            %
            light_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
            uimenu('Parent',light_context_menu,'Label','Ambient Light Color','Callback','change_ambientlight_color');
            uimenu('Parent',light_context_menu,'Label','Light Color','Callback','change_light_color');
            light_lightstyle_menu = uimenu('Parent',light_context_menu,'Label','Light Style');
            if strcmp(get(my_light,'Style'),'infinite')==1;
               uimenu('Parent',light_lightstyle_menu,'Label','Infinite','Checked','on','Callback','change_light_style');
               uimenu('Parent',light_lightstyle_menu,'Label','Local','Checked','off','Callback','change_light_style');
            else;
               uimenu('Parent',light_lightstyle_menu,'Label','Infinite','Checked','off','Callback','change_light_style');
               uimenu('Parent',light_lightstyle_menu,'Label','Local','Checked','on','Callback','change_light_style');
            end;
            uimenu('Parent',light_context_menu,'Label','Unlock Light','Separator','on','Callback','light_lock_fcn');
            set(light_line,'UIContextMenu',light_context_menu);
         end;
         axes_light_menu = uimenu('Parent',axes_context_menu,'Label','Light Visibility');
         if strcmp(get(light_line,'Visible'),'on')==1;
            uimenu('Parent',axes_light_menu,'Label','Hide','Checked','off','Callback','show_hide_light');
            uimenu('Parent',axes_light_menu,'Label','Show','Checked','on','Callback','show_hide_light');
         else;
            uimenu('Parent',axes_light_menu,'Label','Hide','Checked','on','Callback','show_hide_light');
            uimenu('Parent',axes_light_menu,'Label','Show','Checked','off','Callback','show_hide_light');
         end;
         %
         % determine current light position relative to surface
         %
         light_surf = get(my_light,'UserData');
         surf_pos1 = 'off';
         surf_pos2 = 'off';
         surf_pos3 = 'off';
         surf_pos4 = 'off';
         surf_pos5 = 'off';
         surf_pos6 = 'off';
         surf_pos7 = 'off';
         surf_pos8 = 'off';
         if [min(min(get(light_surf,'XData'))) min(min(get(light_surf,'YData'))) min(min(get(light_surf,'ZData')))]==light_pos;
            surf_pos1 = 'on';
         elseif [min(min(get(light_surf,'XData'))) min(min(get(light_surf,'YData'))) max(max(get(light_surf,'ZData')))]==light_pos;
            surf_pos2 = 'on';
         elseif [min(min(get(light_surf,'XData'))) max(max(get(light_surf,'YData'))) min(min(get(light_surf,'ZData')))]==light_pos;
            surf_pos3 = 'on';
         elseif [min(min(get(light_surf,'XData'))) max(max(get(light_surf,'YData'))) max(max(get(light_surf,'ZData')))]==light_pos;
            surf_pos4 = 'on';
         elseif [max(max(get(light_surf,'XData'))) min(min(get(light_surf,'YData'))) min(min(get(light_surf,'ZData')))]==light_pos;
            surf_pos5 = 'on';
         elseif [max(max(get(light_surf,'XData'))) min(min(get(light_surf,'YData'))) max(max(get(light_surf,'ZData')))]==light_pos;
            surf_pos6 = 'on';
         elseif [max(max(get(light_surf,'XData'))) max(max(get(light_surf,'YData'))) min(min(get(light_surf,'ZData')))]==light_pos;
            surf_pos7 = 'on';
         elseif [max(max(get(light_surf,'XData'))) max(max(get(light_surf,'YData'))) max(max(get(light_surf,'ZData')))]==light_pos;
            surf_pos8 = 'on';
         end;
         axes_lightposition_menu = uimenu('Parent',axes_context_menu,'Label','Light Position');
            uimenu('Parent',axes_lightposition_menu,'Label','min(X) min(Y) min(Z)','Checked',surf_pos1,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','min(X) min(Y) max(Z)','Checked',surf_pos2,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','min(X) max(Y) min(Z)','Checked',surf_pos3,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','min(X) max(Y) max(Z)','Checked',surf_pos4,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','max(X) min(Y) min(Z)','Checked',surf_pos5,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','max(X) min(Y) max(Z)','Checked',surf_pos6,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','max(X) max(Y) min(Z)','Checked',surf_pos7,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','max(X) max(Y) max(Z)','Checked',surf_pos8,'Callback','change_light_position');
      else;
         if isempty(get(myaxes(1,i),'Children'))==0;
            uimenu('Parent',axes_context_menu,'Separator','on','Enable','on','Label','Statistics','Callback','axes_statistics_fcn');
         else;
            uimenu('Parent',axes_context_menu,'Separator','on','Enable','off','Label','Statistics','Callback','axes_statistics_fcn');
         end;

         %
         % Deal with X and Y labels
         %
         %
         % check if we need to add Match Data Units functions
         %
         fix_y = 0;
         fix_x = 0;
         ytick = get(myaxes(1,i),'YTick');
         ylabels = get(myaxes(1,i),'YTickLabel');
         if ((isalmostequal(mystr2num(strtrim(ylabels(1,:))),ytick(1,1))==0)|(isalmostequal(mystr2num(strtrim(ylabels(size(ylabels,1),:))),ytick(1,size(ytick,2)))==0))&(size(ytick,2)>=2);
            fix_y = 1;
         end;
         xtick = get(myaxes(1,i),'XTick');
         xlabels = get(myaxes(1,i),'XTickLabel');
         if ((isalmostequal(mystr2num(strtrim(xlabels(1,:))),xtick(1,1))==0)|(isalmostequal(mystr2num(strtrim(xlabels(size(xlabels,1),:))),xtick(1,size(xtick,2)))==0))&(size(xtick,2)>=2);
            fix_x = 1;
         end;
         %
         % add controls if necessary
         %
         if (fix_x==1)|(fix_y==1)|(strcmp(get(myaxes(1,i),'XTickLabelMode'),'manual')==1)|(strcmp(get(myaxes(1,i),'YTickLabelMode'),'manual')==1);
            axes_tick_menu = uimenu('Parent',axes_context_menu,'Separator','on','label','Match Data Units');
         end;
         if fix_x==1;
            uimenu('Parent',axes_tick_menu,'Label','Match X Axis','Callback','fix_xtix_fcn');
         elseif strcmp(get(myaxes(1,i),'XTickLabelMode'),'manual')==1;
            uimenu('Parent',axes_tick_menu,'Label','Automatic X Axis Labels','Callback','fix_xtix_fcn');
         end;
         if fix_y==1;
            uimenu('Parent',axes_tick_menu,'Label','Match Y Axis','Callback','fix_ytix_fcn');
         elseif strcmp(get(myaxes(1,i),'YTickLabelMode'),'manual')==1;
            uimenu('Parent',axes_tick_menu,'Label','Automatic Y Axis Labels','Callback','fix_ytix_fcn');
         end;


      end;
      %
      curr_colorbar = [];
      if isempty(this_colorbar)==0;
         for j=1:size(this_colorbar,2);
            if get(this_colorbar(1,j),'UserData')==myaxes(1,i);
               curr_colorbar = this_colorbar(1,j);
               break;
            end;
         end;
      end;
      %
      if (size(myaxes,2)>1)|((isempty(curr_colorbar)==0)&(ishandle(curr_colorbar)==1)&(strcmp(get(curr_colorbar,'Visible'),'on')==1));
         uimenu('Parent',axes_context_menu,'Label','Copy Subplot','Separator','on','Callback','copy_subplot_fcn');
      end;
      if (isempty(this_axes(i).surface)==1)&(x_zeros(1,i)==0);
         uimenu('Parent',axes_context_menu,'Label','Y Axis Zero Line','Callback','x_zeros_fcn');
      end;
      set(myaxes(1,i),'UIContextMenu',axes_context_menu);
      %
      % Context menu for surfaces
      %
      if isempty(this_axes(i).surface)==0;
         check_surf = 0;
         surf_handle = [];
         for j=1:size(this_axes(i).surface,2);
            if isnumeric(get(this_axes(i).surface(1,j),'UserData'))==0;
               check_surf = 1;
               surf_handle = this_axes(i).surface(1,j);
               break;
            end;
         end;
         %
         % make sure all surfaces have the same context menu
         %
         if check_surf==1;
            for j=1:size(this_axes(i).surface,2);
               surface_context = toolbar_surface_context(surf_handle);
               set(this_axes(i).surface(1,j),'UIContextMenu',surface_context);
            end;
         else;
            for j=1:size(this_axes(i).surface,2);
               surface_context = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
               uimenu('Parent',surface_context,'label','Cut','Callback','delete_surface_fcn');
               set(this_axes(i).surface(1,j),'UIContextMenu',surface_context);
            end;
         end;
      end;
      %
      % create a context menu for title object
      %
      title_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
      uimenu('Parent',title_context_menu,'Label','Edit','Callback','set(get(gca,''Title''),''Editing'',''on'')');
      uimenu('Parent',title_context_menu,'Separator','on','Label','Font','Callback','change_title_font');
      uimenu('Parent',title_context_menu,'Label','Font Color','Callback','change_title_color');
      set(get(myaxes(1,i),'Title'),'UIContextMenu',title_context_menu);
      %
      % create a context menu for x-label
      %
      xlabel_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
      uimenu('Parent',xlabel_context_menu,'Label','Edit','Callback','set(get(gca,''XLabel''),''Editing'',''on'')');
      uimenu('Parent',xlabel_context_menu,'Separator','on','Label','Font','Callback','change_xlabel_font');
      uimenu('Parent',xlabel_context_menu,'Label','Font Color','Callback','change_xlabel_color');
      set(get(myaxes(1,i),'XLabel'),'UIContextMenu',xlabel_context_menu);
      %
      % create a context menu for y-label
      %
      ylabel_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
      uimenu('Parent',ylabel_context_menu,'Label','Edit','Callback','set(get(gca,''YLabel''),''Editing'',''on'')');
      uimenu('Parent',ylabel_context_menu,'Separator','on','Label','Font','Callback','change_ylabel_font');
      uimenu('Parent',ylabel_context_menu,'Label','Font Color','Callback','change_ylabel_color');
      set(get(myaxes(1,i),'YLabel'),'UIContextMenu',ylabel_context_menu);
      %
      % create a context menu for y-label
      %
      zlabel_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
      uimenu('Parent',zlabel_context_menu,'Label','Edit','Callback','set(get(gca,''ZLabel''),''Editing'',''on'')');
      uimenu('Parent',zlabel_context_menu,'Separator','on','Label','Font','Callback','change_zlabel_font');
      uimenu('Parent',zlabel_context_menu,'Label','Font Color','Callback','change_zlabel_color');
      set(get(myaxes(1,i),'ZLabel'),'UIContextMenu',zlabel_context_menu);
      %
      % create a context menu for any legends found
      %
      myleg = get(myaxes(1,i),'UserData');
      if isempty(myleg)==1;
         myleg = find_legend(myaxes(1,i));
      end;
      if isempty(myleg)==0;
         if ishandle(myleg)==1;
            leg_ud = get(myleg,'UserData');
            legcontext = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
            uimenu('Parent',legcontext,'Label','Font','Callback','change_legend_font');
            uimenu('Parent',legcontext,'Label','Text Color','Separator','on','Callback','change_legend_text_color');
            uimenu('Parent',legcontext,'Label','Background Color','Callback','change_axes_color');
            uimenu('Parent',legcontext,'Label','Border Color','Callback','change_legend_color');
            leg_ud.UIContextMenu = legcontext;
            set(myleg,'UIContextMenu',legcontext,'UserData',leg_ud);
            set(get(myleg,'Children'),'UIContextMenu',legcontext);
            if strcmp(lower(get(myleg,'Visible')),'on')==1;
               b_lh = 1;
            end;
         end;
      end;
   end;
end;

if b_lh==1;
   menu_objects = findall(h,'Type','uimenu','Label','Show Le&gend')';
   if isempty(menu_objects)==0;
      %
      set(menu_objects,'HandleVisibility','on','Label','Hide Le&gend');
      refresh(h);
   end;
end;

if isempty(mylines)==0;
   %
   % add legend line handle to userdata of line
   % and legend patch handle to userdata of patch
   %
   for i=1:size(myaxes,2);
      if isempty(this_axes(i).line)==0;
         if isempty(this_axes(i).ud)==0;
            this_leg_handles = this_axes(i).ud.handles';
            if size(this_leg_handles,1)>1;
               this_leg_handles = this_leg_handles';
            end;
            for j=1:size(this_axes(i).line,2);
               for i1=1:size(this_leg_handles,2);
                  if this_axes(i).line(1,j)==this_leg_handles(1,i1);
                     c_leg_lines = sort(this_axes(i).legendline);
                     for j1=1:size(c_leg_lines,2);
                        line_col = get(this_axes(i).line(1,j),'Color');
                        line_wid = get(this_axes(i).line(1,j),'LineWidth');
                        line_typ = get(this_axes(i).line(1,j),'LineStyle');
                        line_mark = get(this_axes(i).line(1,j),'Marker');
                        leg_col = get(c_leg_lines(1,j1),'Color');
                        leg_wid = get(c_leg_lines(1,j1),'LineWidth');
                        leg_typ = get(c_leg_lines(1,j1),'LineStyle');
                        leg_mark = get(c_leg_lines(1,j1),'Marker');
                        if (line_col==leg_col)&(line_wid==leg_wid)&(strcmp(line_typ,leg_typ)==1)&(strcmp(line_mark,leg_mark));
                           set(this_axes(i).line(1,j),'UserData',c_leg_lines(1,j1));
                           break;
                        end;
                     end;
                  end;
               end;
            end;
         end;
      end;
   end;
end;

if isempty(mypatches)==0;
   for i=1:size(myaxes,2);
      if isempty(this_axes(i).patch)==0;
         if isempty(this_axes(i).ud)==0;
            this_leg_handles = this_axes(i).ud.handles';
            if size(this_leg_handles,1)>1;
               this_leg_handles = this_leg_handles';
            end;
            for j=1:size(this_axes(i).patch,2);
               for i1=1:size(this_leg_handles,2);
                  if this_axes(i).patch(1,j)==this_leg_handles(1,i1);
                     c_leg_patch = sort(this_axes(i).legendpatch);
                     for j1=1:size(c_leg_patch,2);
                        patch_edgecol = get(this_axes(i).patch(1,j),'EdgeColor');
                        patch_facecol = get(this_axes(i).patch(1,j),'FaceColor');
                        patch_wid = get(this_axes(i).patch(1,j),'LineWidth');
                        patch_typ = get(this_axes(i).patch(1,j),'LineStyle');
                        patch_mark = get(this_axes(i).patch(1,j),'Marker');
                        leg_edgecol = get(c_leg_patch(1,j1),'EdgeColor');
                        leg_facecol = get(c_leg_patch(1,j1),'FaceColor');
                        leg_wid = get(c_leg_patch(1,j1),'LineWidth');
                        leg_typ = get(c_leg_patch(1,j1),'LineStyle');
                        leg_mark = get(c_leg_patch(1,j1),'Marker');
                        if (patch_edgecol==leg_edgecol)&(patch_facecol==leg_facecol)&(patch_wid==leg_wid)&(strcmp(patch_typ,leg_typ)==1)&(strcmp(patch_mark,leg_mark)==1);
                           set(this_axes(i).patch(1,j),'UserData',c_leg_patch(1,j1));
                           break;
                        end;
                     end;
                  end;
               end;
            end;
         end;
      end;
   end;
end;

%
% end of toolbar_fcn.m
%
