function [h_b,H_b] = vecbetarel(beta,n,r,dcoint,q1,modelsdir,modelfile)

%
% Get the normalizing variables
%
file = strcat(modelsdir,'normalize-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.norm');
normvec = loaddata(file);
I_mat = eye(size(beta,1));
h_b = [];
H_b = [];
tot_free = 0;
%
% get restrictions on beta
%
for i=1:r;
   file = strcat(modelsdir,'H_',num2str(i),'-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.rest');
   if fileexist(file)==1;
      H_i = loaddata(file);
      %
      % determine which rows in H_i are linearly independend
      %
      H_fix = H_i(normvec(i),:);
      j = 1;
      while j<=size(H_i,1);
        if size(H_fix,1)<size(H_fix,2);
           if j~=normvec(i);
              H_test = [H_fix;H_i(j,:)];
              if rank(H_test)==size(H_test,1);
                 H_fix = H_test;
              end;
           end;
           j = j+1;
        else;
           j = size(H_i,1)+1;
        end;
      end;
      H_i = H_i/H_fix;
      h_i = H_i(:,1);
      h_b = [h_b;h_i];
      if size(H_i,2)>1;
         H_i = H_i(:,2:size(H_i,2));
      else;
         H_i = [];
      end;
      H_struc.elem(i).H_i = H_i;
      H_struc.elem(i).tot_free = tot_free;
      tot_free = tot_free+size(H_i,2);
   end;
end;
%
% now we construct H from the above info
%
for i=1:r;
   if isempty(H_struc.elem(i).H_i)==1;
      H_b = [H_b;zeros(size(beta,1),tot_free)];
   else;
      H_i = H_struc.elem(i).H_i;
      my_free = H_struc.elem(i).tot_free;
      if my_free>0;
         H_first = zeros(size(beta,1),my_free);
      else;
         H_first = [];
      end;
      if tot_free-(my_free+size(H_i,2))>0;
         H_last = zeros(size(beta,1),tot_free-(my_free+size(H_i,2)));
      else;
         H_last = [];
      end;
      H_b = [H_b;[H_first H_i H_last]];
   end;
end;

%
% end of vecbetarel.m
%
